<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Contacts extends MY_Controller {

	function __construct(){
		parent::__construct();

		//load helpers
		$this->load->helper(array('html', 'text', 'form', 'url'));
		//load models
		$this->load->model(array('contacts_model', 'categories_model')); // Other models loaded in MY_Controller library
		//set module
        $this->categories_model->setModule('contacts');

		// load the validation library
		$this->load->helper(array());


		$this->load->model('Analytics_model');
		$this->Analytics_model->saveUserInfo();// save visitors info's		              
               
	}


	function index(){

		$data = array(
     		'categories' => $this->categories_model->getTreeRows(),
            'view' => 'contacts_home'
		);

		$this->display('contacts',$this->active_template,$this->pos_sidebar, $data);
	}
	

	
		


	/**
	 * Save contact, upload photo if necessary
	 *
	 * @param int $id
	 */
	function save($id=null){
		
		$this->load->library('form_validation');
		$this->form_validation->set_rules('name', 'Name', 'required');
		$this->form_validation->set_rules('email', 'Email',  'required|valid_email');
		$this->form_validation->set_rules('about', 'Message', 'required');

		if ($this->form_validation->run() == FALSE)
				$this->_setMessage("Please fill all the fields correctly", 'error');
		else
		{
				$result = $this->contacts_model->save();

				if($result === TRUE)
					$this->_setMessage("Your message was successfully save ! thanks.", 'success');
				
				else 	
					$this->_setMessage($result, 'error');
			
		}

		redirect('contacts');

	}

}

/* End of file contact.php */
/* Location: ./application/controllers/contact.php */
