<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Items extends MY_Controller {
	
	//path to the site mgr installation
	//usually blank or 'admin/'
	var $site_mgr_path = 'backoffice/';
	
	function __construct(){
		parent::__construct();
					
		$this->load->model('Items_model');
		$this->load->model('Categories_model');
		$this->Categories_model->setModule('items');
	}
	
	function index(){
		$this->page();
	}
	
	function page($offset=0){
		/*if($this->session->userdata('items_category'))
			redirect('items/category/' . $this->session->userdata('items_category'));
		*/
		
		$this->load->library('pagination');

		$config['base_url'] = site_url('backoffice/items/page');
		$config['total_rows'] = $this->Items_model->countMerch();
		$config['per_page'] = 20;
		$config['uri_segment'] = 3;
		$config['num_links'] = 4;
		
		$this->pagination->initialize($config);
		
		$data = array(
			'merch' => $this->Items_model->getMerch(NULL, $offset, $config['per_page']),
			'categories' => $this->Categories_model->getTreeRows(),
			'pages_links' => $this->pagination->create_links(),
			'search_str'=> 'Enter a keyword',
			'mysearch' => TRUE,
			'sub_nav' => 'items',
			'view' => 'items_home'
		);

		$this->display('items', $this->active_template, $this->pos_sidebar,  $data);
	}
	
	
	
	function search($offset=0){

		
		$this->load->library('pagination');

		$config['base_url'] = site_url('items/search');
		$config['total_rows'] = $this->Items_model->countMerch();
		$config['per_page'] = 20;
		$config['uri_segment'] = 3;
		$config['num_links'] = 4;
		
		$this->pagination->initialize($config);

		$data = array(
			'merch' => $this->Items_model->search($this->input->post('search_str')),
			'categories' => $this->Categories_model->getTreeRows(),
			'pages_links' => $this->pagination->create_links(),
			'search_str' => $this->input->post('search_str'),
			'mysearch' => TRUE,
			'sub_nav' => 'items',
			'view' => 'home'
		);
		
		$this->display('items', $this->active_template, $this->pos_sidebar,  $data);
	}
	
	/**
	 * Show all items in a category
	 *
	 * @param string $slug
	 */
	function category($slug=null, $offset=0){
		$slug = ($slug == null) ? $_POST['slug'] : $slug;
		
		if($slug == 'ALL'){
			$this->session->unset_userdata('items_category');
			redirect('items');
		} else {
			$this->session->set_userdata('items_category', $slug);

		$this->load->library('pagination');

		$config['base_url'] = site_url('items/category');
		$config['total_rows'] = $this->Items_model->countMerch();
		$config['per_page'] = 20;
		$config['uri_segment'] = 4;
		$config['num_links'] = 4;
		
		$this->pagination->initialize($config);
			
			$data = array(
				'merch' => $this->Items_model->getMerchByCategory($slug),
				'categories' => $this->Categories_model->getTreeRows(),
				'pages_links' => $this->pagination->create_links(),
				'slug' => $slug,
				'search_str' => 'Enter a keyword',
				'sub_nav' => 'items',
				'view' => 'items_home'
			);
			
		$this->display('items', $this->active_template, $this->pos_sidebar,  $data);
		}
	}
	
	function details($id=0,$img=NULL){
		if($id == 0)
			redirect('items');
		//details of an existing item
		else {
			$data['row'] = $this->Items_model->getMerch($id)->first_row('array');
			$data['sizes'] = $this->Items_model->getSizes($id);
			$data['categories'] = $this->Categories_model->getTreeRows();

			if ($img == NULL){
				$data['images'] = $this->Items_model->getImages($id);
				$data['num_img'] = 0;
		   }
		   else{
			   $data['images'] = $img;
			   $data['num_img'] = 1;
			}
		}
		$data['search_str'] = 'Enter a keyword';
		$data['sub_nav'] = 'items';
		$data['view'] = 'items_details';
		
		$this->display('items', $this->active_template, $this->pos_sidebar, $data);
	}
}
/* End of file items.php */
/* Location: ./application/controllers/items.php */
