<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Pages extends MY_Controller {

	public  $code_lang;
	
	function __construct(){
		parent::__construct();

		//load helpers
		$this->load->helper(array('html', 'text'));
		//load models
		$this->load->model(array('Pages_model', 'Categories_model', 'Analytics_model'));
		//set module
		$this->Categories_model->setModule('pages');
		//get language		
		$this->code_lang = $this->getCurrentLang();

	}
	
	
	function index($message=NULL){

		$this->Analytics_model->saveUserInfo();// save visitors info's

		$this->page();
		
	}

	function page($offset=0){

		if($this->session->userdata('pages_category'))
			redirect('pages/category/' . $this->session->userdata('pages_category'));
				
		$this->load->library('pagination');

		$config['base_url']	  = site_url('pages/page');
		$config['total_rows'] = $this->Pages_model->countPages(FALSE);
		$config['per_page']   = 10;
		$config['uri_segment']= 3;
		$config['num_links']  = 4;
		
		$this->pagination->initialize($config);

		$data = array(
			'pages'		=> $this->Pages_model->getPages(array('limit'=>$config['per_page'], 'offset'=>$offset, 'published'=>0, 'lang'=>$this->code_lang)),
			'categories'=> $this->Categories_model->getTreeRows(),
			'message'	=> (!isset($message)) ? $message='' : $message,
			'page_links'=> $this->pagination->create_links(),
			'search_str'=> 'Enter a keyword',
			'mysearch'	=> TRUE,
			'sub_nav'	=> 'pages',
			'view'		=> 'pages_home'
		);

		$this->display('pages', $this->active_template, $this->pos_sidebar,  $data);
	}	 

	
	function search(){
		$search_str = $_POST['search_str'];
		$data = array(
			'pages' => $this->Pages_model->searchPages($search_str),
			'categories' => $this->Categories_model->getCategories(),
			'search_str' => $search_str,
			'mysearch' => TRUE,
			'view' => 'pages_home'
		);
		$this->display('pages', $this->active_template, $this->pos_sidebar,  $data);
	}

	
	/**
	 * Show all items in a category
	 *
	 * @param string $cat_id
	 * @param int $offset
	 */
	function category($cat_id=null, $offset=0){

		$cat_id = ($cat_id == null) ? $_POST['cat_id'] : $cat_id;
		
		if($cat_id == 'ALL'){
			$this->session->unset_userdata('pages_category');
			redirect('pages');
		}
		else {

			$this->session->set_userdata('pages_category', $cat_id);

			//setup pagination
			$this->load->library('pagination');
			$config['base_url'] = site_url('Pages/category/'.$cat_id);
			$config['total_rows'] = $this->Pages_model->getPages(array('category_in'=>$cat_id,'published'=>FALSE,'count'=>TRUE, 'lang'=>$this->code_lang));
			$config['per_page'] = 10;
			$config['uri_segment'] = 4;
			$config['num_links'] = 4;
			$this->pagination->initialize($config);
			
			$data = array(
				'pages'		=> $this->Pages_model->getPages(array('category_in'=>$cat_id,'published'=>FALSE,'limit'=>$config['per_page'],'offset'=>$offset, 'lang'=>$this->code_lang)),
				'categories'=> $this->Categories_model->getTreeRows(),
				'page_links'=> $this->pagination->create_links(),
				'crumbs'	=> $this->Categories_model->breadCrumbs($cat_id),
				'search_str'=> 'Enter a keyword',
				'search'	=> TRUE,
				'view'		=> 'pages_home'
			);

		$this->display('pages', $this->active_template, $this->pos_sidebar,  $data);
		}
	}
}

/* End of file pages.php */
/* Location: ./application/controllers/pages.php */
