<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Photos extends MY_Controller {
	
 public function __construct(){
		parent::__Construct();
		
		$this->load->model('Photos_model');  
		$this->load->model('Categories_model');  
		
		$this->Categories_model->setModule('photos');

	}
	
	public function index($offset=0){

		if($this->session->userdata('photos_category'))
			redirect('photos/category/' . $this->session->userdata('photos_category'));
			
		$this->load->library('pagination');

		$config['base_url'] = site_url('photos/page');
		$config['total_rows'] = $this->Photos_model->getCount();
		$config['per_page'] = 10;
		$config['uri_segment'] = 3;
		$config['num_links'] = 4;
			
		$this->pagination->initialize($config);
		
		$data = array(
			'photos' => $this->Photos_model->getPhotos(array('limit'=>$config['per_page'], 'offset'=>$offset)),
			'categories' => $this->Categories_model->getTreeRows(),
			'pages_links' => $this->pagination->create_links(),
			'sub_nav'=>'photos',
			'view' => 'photos_home'
			
		);
		$this->display('photos', $this->active_template, $this->pos_sidebar, $data);
	}
	
	public function page($offset=0){
		$this->index($offset);
	}
	
	/**
	 * Show all items in a category
	 *
	 * @param string $cat_id
	 * @param int $offset
	 */
	function category($cat_id=NULL, $offset=0){

		$cat_id = ($cat_id == null) ? $_POST['cat_id'] : $cat_id;
		 		 
		if($cat_id == 'ALL'){
			$this->session->unset_userdata('photos_category');
			redirect('photos');
		}
		else {
			$this->session->set_userdata('photos_category', $cat_id);

			//setup pagination
			$this->load->library('pagination');
			$config['base_url']		 = site_url('photos/category/'.$cat_id);
			$config['total_rows']	 = $this->Photos_model->getCount();
			$config['per_page']		 = 10;
			$config['uri_segment']	 = 4;
			$config['num_links']	 = 4;
			$this->pagination->initialize($config);
			
			$data = array(
				'photos'		=> $this->Photos_model->getPhotos(array('category_in'=>$cat_id,'limit'=>$config['per_page'],'offset'=>$offset)),
				'pages_links'=> $this->pagination->create_links(),
				'module'    => $this->Categories_model->module,
				'crumbs'	=> $this->Categories_model->breadCrumbs($cat_id),
				'mysearch' 		=> TRUE,
				'sub_nav'	=> 'photos',
				'view'		=> 'photos_home'
			);

		$this->display('photos', $this->active_template, $this->pos_sidebar, $data);
		}
	}
	
	public function view($id){
		
		$data = array(
			'row' => $this->Photos_model->getPhoto($id)->first_row('array'),
			'tags' => $this->Photos_model->getTagsOnPhoto($id),
			'categories' => $this->Categories_model->getTreeDD(),
			'sub_nav'=>'photos',
			'view' => 'photos_view'
		);
		
		$this->display('photos', $this->active_template, $this->pos_sidebar, $data);
	}
	
	public function sizes($photo_id, $size){
		$data = array(
			'size'=> ($size == 'O') ? '' : $size,
			'row' => $this->Photos_model->getPhoto($photo_id)->first_row('array'),
			'sub_nav'=>'photos',
			'view' => 'photos_size'
		);
		
		$this->display('photos', $this->active_template, $this->pos_sidebar, $data);
	}
	
	public function changeCategory($photo_id){
		$cat=$this->Photos_model->changeCategory($photo_id, $this->input->post('category'));
		
		//$cat = $this->Photos_model->getCategory($this->input->post('category'))->first_row('array');
		
		echo "$cat[category]&nbsp;&nbsp;
			<a href='#' onClick=\"$('curr_cat').hide(); $('edit_cat').show(); return false;\">Edit</a>.";

	}

	/**
	 * Display tags on a photo. AJAX calls this!
	 *
	 * @param int $photo_id
	 */
	public function showTags($photo_id){
		foreach($this->photos_model->getTagsOnPhoto($photo_id)->result_array() as $tag)
			echo "<a href='".site_url("backoffice/photos/tag/$tag[tag]")."'>$tag[tag]</a>&nbsp;
			<span class='del' style='font-size: 10px;'><a href='#' onClick=\"new Ajax.Updater('tag_box', '".site_url("backoffice/photos/deleteTag/$photo_id/$tag[id]")."', {evalScripts: true}); return false;\" title='Delete this tag?'>
				x</a></span><br/>";
	}

}

