<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Register extends MY_Controller {

   private $opts;
   private $site_name;
	public function __construct () {
      
		parent::__construct ();
		$this->load->model('Settings_model');

		$this->opts=$this->Settings_model->getOptions('general');

		$can_register=$this->opts['anyone_can_register']['option_value'];
		if(!$can_register){
       
			$this->_setMessage('You are not authorised to create account','warning');
			redirect("pages");
      }

		$this->site_name= $this->opts['site_name']['option_value'];
	}

	function index () {


		
		$this->form_validation->set_rules('email_address', $this->lang->line('email_address'), 'required|valid_email|callback_form_email_check');
		$this->form_validation->set_rules('password', $this->lang->line('password'), 'required' );
		$this->form_validation->set_rules('password_conf', $this->lang->line('account_password_conf'), 'required|matches[password]');
		$this->form_validation->set_rules('display_name', $this->lang->line('display_name'), 'required');


      if($_POST){
        $code = $_POST['imagecode'];
        $this->load->library("securimage");
        $check_code   = $this->securimage->check($code);
  
      }
      if ( (!$this->form_validation->run()) || ( $check_code==false)) {

				$data = array(
					'sub_nav'=> 'register',
					'view' => 'register'
				);
       //  $this->_setMessage("Please field captcha and password correctly",'warning');
      	$this->display('register', $this->active_template,  $this->pos_sidebar, $data);
       }
	
		else {
			
			unset($_POST['password_conf']);
			unset($_POST['btnSubmit']);
         unset($_POST['imagecode']);

         $_POST['registered']=date('Y-m-d H:i:s');
         $_POST['user_level'] = 5;
			
			$code_activation=random_string('alnum',16);
			//Save User
			$result = $this->Users_model->save($user_id,$code_activation);

         if($this->opts['mail_activation']['option_value']=='on' && $this->opts['smtp_host']['option_value']=='on'){

            
               $mailsend=$this->activation_mail($_POST['email_address'],$code_activation);
               
               if($mailsend){
                 
                  $message = "<img src='".base_url()."/assets/themes/candlecms/images/tick.png'>  Account has been created, Please check your mail to activate your account !";
                  $this->_setMessage($message, 'success');

                   redirect("candlecms/activation");

               }
               else{
                  $message = "<img src='".base_url()."/assets/themes/candlecms/images/cross.png'>  Account has been created, The activation mail was not delivered successfully.Please contact your administrator to activate your account";
                  $this->_setMessage($message, 'warning');


                redirect('register');

               }
          
		
         }
         else{
             $message = "<img src='".base_url()."/assets/themes/candlecms/images/cross.png'>  Account has been created, Please contact your administrator to activate your account";
             $this->_setMessage($message, 'warning');
             redirect('register');
         }
		}

	}	

    public function form_email_check($email_address) {
		
		if ($this->Users_model->get_user_by_email($email_address)) {
			$this->form_validation->set_message('form_email_check', $this->lang->line('account_email_unavailable'));
			return FALSE;
		}
		else {
			return TRUE;
		}
	}
	
	public function activation_mail($email_address,$code_activation){
		
		
		
			$config['protocol'] = 'smtp';
			$config['smtp_host'] = 'localhost';
			$config['mailpath'] = '/usr/sbin/sendmail';
			$config['charset'] = 'iso-8859-1';
			$config['wordwrap'] = TRUE;
			
			$headers = "MINE-Version: 1.0\r\n";
			
			$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
		//generate an activation Code
		
			$activation_link=" Follow this link to activate your account :  <a href=".site_url('candlecms/activation').">Activation here</a>";

			$mailmessage=" Welcome on $this->site_name !  <p>Your activation code is : $code_activation <br/> $activation_link <br/>Please, activate your account before logging in.</p>";
         $mailmessage.="<p> If you haven't created an account on ".site_url().", don't react to this mail.</p>";
		//sending the activation code by email
			if(mail($email_address,"$this->site_name : Registration Confirmation - Your activation code",$mailmessage,$headers)){
					$mailsend=TRUE;
			}
			else{
					$this->load->library('email');
					//$this->email->initialize($config);
					$this->email->from($this->config->item('newsletter_email'));
					$this->email->to($email_address);
					$this->email->subject("$this->site_name : Registration Confirmation - Your activation code");
					$mailsend=$this->email->send();
				}
		return $mailsend;
	}
}

/* End of file register.php */
/* Location: ./application/controllers/register.php */
