<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * ExiteCMS
 *
 * An open source application development framework for PHP 5+
 * ExiteCMS is based on CodeIgniter, Copyright (c) Ellislab Inc.
 *
 * Default model parent class to transparently support both CI 1.7.2 and 2.0
 *
 * @package		ExiteCMS
 * @author		WanWizard
 * @copyright	Copyright (c) 2010, ExiteCMS.org
 * @link		http://www.exitecms.org
 * @filesource
 */

// ------------------------------------------------------------------------
/*
if ( ! class_exists('CI_Model') )
{
	class CI_Model extends Model
	{
		function CI_Model()
		{
			parent::__construct();
		}
	}
}
*/

/**
 * CodeIgniter Model Class
 *
 * @package		CodeIgniter
 * @subpackage	Libraries
 * @category	Libraries
 * @author		ExpressionEngine Dev Team
 * @link		http://codeigniter.com/user_guide/libraries/config.html
 */
class MY_Model extends CI_Model {

    public $table_opts = 'options';
    public $table_users	= 'users';    
    
	/**
	 * __isset
	 *
	 * Test if a CI's loaded is present
	 *
	 * @access private
	 */
	function __isset($key)
	{
		$CI =& get_instance();
		return isset($CI->$key);
	}
	
	
	
	/**
	 * Return an option value, for use outside of the model
	 * 
	 * @deprecated use config_item(); (CI globally available)
	 *
	 * @param string $option_name
	 * @return string
	 */
	public function getOption($option_name){
		
		//set config options
		$module = (!isset($this->module) || $this->module == NULL) ? $this->uri->segment(2) : $this->module;
		
		$res = $this->db->query('SELECT * FROM `' . $this->db->dbprefix($this->table_opts) . '` WHERE category IN ("' . $module . '","general")');
		
		
		foreach($res->result_array() as $row){
			$result_arr[$row['option_name']] = $row['option_value'];
			//use CI's config class
			$this->config->set_item($row['option_name'], $row['option_value']);
		}
		
		$this->options = $result_arr;
		
		return $this->options[$option_name];
	}	
	
	function getUsers($args=NULL){

		if ( isset($args['user_id']) && $args['user_id']==0 ) {
			
			$res = $this->db->get($this->db->dbprefix($this->table_users));

		} else {

			if (isset($args['user_id'])) {
				$this->db->where('user_id', $args['user_id']);
			}
					
			if (isset($args['display_name']) && $args['display_name']) {
				$this->db->where('display_name', $args['display_name']);
			}

			$res = $this->db->get($this->db->dbprefix($this->table_users), $args);

		}

		return $res;
	}
}
// END MY_Model Class

/* End of file MY_Model.php */
/* Location: ./application/core/MY_Model.php */
