<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

include_once APPPATH . "libraries/UTF8.php";

function searchdir ( $path, $maxdepth = -1, $mode = "FULL", $d = 0 ) {
	if ( substr ( $path, strlen ( $path ) - 1 ) != '/' ) {
		$path .= '/';
	}
	$dirlist = array ();
	if ( $mode != "FILES" ) {
		$dirlist [] = $path;
	}
	
	if ( $handle = opendir ( $path ) ) {
		while ( false !== ( $file = readdir ( $handle ) ) ) {
			if ( $file != '.' && $file != '..' ) {
				$file = $path . $file;
				if ( ! is_dir ( $file ) ) {
					if ( $mode != "DIRS" ) {
						$dirlist [] = $file;
					}
				}
				elseif ( $d >= 0 && ( $d < $maxdepth || $maxdepth < 0 ) ) {
					$result = searchdir ( $file . '/', $maxdepth, $mode, $d + 1 );
					$dirlist = array_merge ( $dirlist, $result );
				}
			}
		}
		closedir ( $handle );
	}
	if ( $d == 0 ) {
		natcasesort ( $dirlist );
	}
	return ( $dirlist );
}


function mkdir_recursive ( $pathname, $mode = 0777 ) {
	is_dir ( dirname ( $pathname ) ) || mkdir_recursive ( dirname ( $pathname ), $mode );
	return is_dir ( $pathname ) || @mkdir ( $pathname, $mode );
}

/**
 * Patch for PHP 5 - 5.2
 * @author	Kromack
 * @link	http://codeigniter.com/forums/viewreply/694827/
*/ 
if (!function_exists('array_replace'))
{
    function array_replace($array, $array1, $value=array())
    {
        foreach($array as $k=>$v)
        {
            if(array_key_exists($k, $array1))
            {
                $array[$k] = $array1[$k];
            }
        }
        return $array;
    }
}

function get_child_permissions_array ( $parent ) {
	$CI = &get_instance ();
	$CI->load->model ( 'permissions_model' );
	return $CI->permissions_model->get_child_permissions_array ( $parent );
}

function is_logged_in () {
	$CI = &get_instance ();
	return ( $CI->session->userdata ('user_level') ) ? TRUE : FALSE;
}


function read_file ( $filename ) {
	$handle = @fopen ( $filename, "r" );
	if ( $handle ) {
		while ( ! feof ( $handle ) ) {
			$lines [] = fgets ( $handle, 4096 );
		}
		fclose ( $handle );
		return $lines;
	}
	return FALSE;
}

function write_file ( $filename, $content ) {
	if ( $handle = fopen ( $filename, 'w' ) ) {
		if ( is_really_writable ( $filename ) ) {
			if ( fwrite ( $handle, $content ) === FALSE ) {
				return FALSE;
			}
			fclose ( $handle );
			return TRUE;
		}
		else {
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
}

function __rmdir_r ( $dir, $DeleteMe = TRUE ) {
	if ( ! SAFE_MODE ) {
		ini_set ( "max_execution_time", "300" );
	}
	
	if ( is_file ( $dir ) ) {
		@unlink ( $dir );
	}
	else {
		if ( ! $dh = @opendir ( $dir ) )
			return;
		while ( false !== ( $obj = readdir ( $dh ) ) ) {
			if ( $obj == '.' || $obj == '..' ) {
				continue;
			}
			
			if ( ! @unlink ( $dir . '/' . $obj ) ) {
				rmdir_r ( $dir . '/' . $obj, true );
			}
		}
		
		closedir ( $dh );
		if ( $DeleteMe ) {
			@rmdir ( $dir );
		}
	}
	
	return TRUE;
}

/**
 * A function for making time periods readable
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     2.0.0
 * @link        http://aidanlister.com/2004/04/making-time-periods-readable/
 * @param       int     number of seconds elapsed
 * @param       string  which time periods to display
 * @param       bool    whether to show zero time periods
 */
function nicetime ( $seconds, $use = null, $zeros = false ) {
	// Define time periods
	$periods = array ( 
		
		'years' => 31556926, 
		'Months' => 2629743, 
		'weeks' => 604800, 
		'days' => 86400, 
		'hours' => 3600, 
		'minutes' => 60, 
		'seconds' => 1 
	);
	
	// Break into periods
	$seconds = ( float ) $seconds;
	foreach ( $periods as $period => $value ) {
		if ( $use && strpos ( $use, $period [ 0 ] ) === false ) {
			continue;
		}
		$count = floor ( $seconds / $value );
		if ( $count == 0 && ! $zeros ) {
			continue;
		}
		$segments [ strtolower ( $period ) ] = $count;
		$seconds = $seconds % $value;
	}
	
	// Build the string
	foreach ( $segments as $key => $value ) {
		$segment_name = substr ( $key, 0, - 1 );
		$segment = $value . ' ' . $segment_name;
		if ( $value != 1 ) {
			$segment .= 's';
		}
		$array [] = $segment;
	}
	
	$str = implode ( ', ', $array );
	return $str;
}

function get_image_colors ( $image ) {
	if ( is_file ( $image ) ) {
		$PREVIEW_WIDTH = 150; //WE HAVE TO RESIZE THE IMAGE, BECAUSE WE ONLY NEED THE MOST SIGNIFICANT COLORS.
		$PREVIEW_HEIGHT = 150;
		$size = GetImageSize ( $image );
		$scale = 1;
		if ( $size [ 0 ] > 0 )
			$scale = min ( $PREVIEW_WIDTH / $size [ 0 ], $PREVIEW_HEIGHT / $size [ 1 ] );
		if ( $scale < 1 ) {
			$width = floor ( $scale * $size [ 0 ] );
			$height = floor ( $scale * $size [ 1 ] );
		}
		else {
			$width = $size [ 0 ];
			$height = $size [ 1 ];
		}
		$image_resized = @imagecreatetruecolor ( $width, $height );
		if ( $size [ 2 ] == 1 )
			$image_orig = @imagecreatefromgif ( $image );
		if ( $size [ 2 ] == 2 )
			$image_orig = @imagecreatefromjpeg ( $image );
		if ( $size [ 2 ] == 3 )
			$image_orig = @imagecreatefrompng ( $image );
		@imagecopyresampled ( $image_resized, $image_orig, 0, 0, 0, 0, $width, $height, $size [ 0 ], $size [ 1 ] ); //WE NEED NEAREST NEIGHBOR RESIZING, BECAUSE IT DOESN'T ALTER THE COLORS
		$im = $image_resized;
		$imgWidth = imagesx ( $im );
		$imgHeight = imagesy ( $im );
		for ( $y = 0; $y < $imgHeight; $y ++ ) {
			for ( $x = 0; $x < $imgWidth; $x ++ ) {
				$index = @imagecolorat ( $im, $x, $y );
				$Colors = @imagecolorsforindex ( $im, $index );
				$Colors [ 'red' ] = intval ( ( ( $Colors [ 'red' ] ) + 15 ) / 32 ) * 32; //ROUND THE COLORS, TO REDUCE THE NUMBER OF COLORS, SO THE WON'T BE ANY NEARLY DUPLICATE COLORS!
				$Colors [ 'green' ] = intval ( ( ( $Colors [ 'green' ] ) + 15 ) / 32 ) * 32;
				$Colors [ 'blue' ] = intval ( ( ( $Colors [ 'blue' ] ) + 15 ) / 32 ) * 32;
				if ( $Colors [ 'red' ] >= 256 )
					$Colors [ 'red' ] = 240;
				if ( $Colors [ 'green' ] >= 256 )
					$Colors [ 'green' ] = 240;
				if ( $Colors [ 'blue' ] >= 256 )
					$Colors [ 'blue' ] = 240;
				$hexarray [] = substr ( "0" . dechex ( $Colors [ 'red' ] ), - 2 ) . substr ( "0" . dechex ( $Colors [ 'green' ] ), - 2 ) . substr ( "0" . dechex ( $Colors [ 'blue' ] ), - 2 );
			}
		}
		$hexarray = array_count_values ( $hexarray );
		natsort ( $hexarray );
		$hexarray = array_reverse ( $hexarray, true );
		
		$out = array ();
		$hex = array_keys ( $hexarray );
		
		for ( $i = 0; $i < 5; $i ++ ) {
			if ( isset ( $hex [ $i ] ) ) {
				array_push ( $out, $hex [ $i ] );
			}
		}
		
		return $out;
	
	}
	return FALSE;
}

function __v ( $var ) {
	echo '<pre>' . var_dump ( $var ) . '</pre>';
	die ();
}

function __p ( $var ) {
	echo '<pre>' . print_r ( $var, true ) . '</pre>';
	die ();
}

function get_y_current_label_state ( $area, $type, $id ) {
	$CI = &get_instance ();
	$CI->load->model ( 'permissions_model' );
	if ( $CI->permissions_model->check_permission_record ( $area, $type, $id ) || $CI->permissions_model->check_parent_permission_record ( $area, $type, $id ) ) {
		return "checked";
	}
}

function form_validation_get_value ( $field, $default_value = '' ) {
	$CI = &get_instance ();
	return ( $CI->form_validation->getField_value ( $field ) ) ? $CI->form_validation->getField_value ( $field ) : $default_value;
}

function form_validation_print_error ( $field, $css_class = null ) {
	$CI = &get_instance ();
	return $CI->form_validation->printField_error ( $field, $css_class );
}

function form_validation_set_select ( $field, $value, $callback = '' ) {
	$CI = &get_instance ();
	return $CI->form_validation->set_select ( $field, $value, $callback );
}

function form_validation_set_checkbox ( $field, $value, $callback = '' ) {
	$CI = &get_instance ();
	return $CI->form_validation->set_checkbox ( $field, $value, $callback );
}

function form_validation_set_radio ( $field, $value, $callback = '' ) {
	$CI = &get_instance ();
	return $CI->form_validation->set_radio ( $field, $value, $callback );
}

function selfUrlClean () {
	$CI = &get_instance ();
	return $CI->uri->segment ( 1 ) . $CI->uri->segment ( 2 );
}


function get_my_session_id () {
	$CI = &get_instance ();
	$session = $CI->session->userdata ( AUTH_SESSION_ID );
	return ( numeric ( $session ) ) ? $session : FALSE;
}

function get_all_session () {

	$CI = &get_instance ();
	if ( $CI->config->item('show_sessions') === 'on' ){
		$session="Start of Sessions<br />\n"; 
		$_sess = 	$CI->session->all_userdata();
			foreach ($_sess as $key => $value) {
				if( is_array($value)){
					$session.="<br />\nStart of rights"; 
					foreach ($value as $_key => $_value) {
						$session.= "<br />\n<b>Key : $_key =></b> "; 
						foreach( $_sess[$key][$_key] as $__key => $__value ){
							$session.= " $__key => $__value\n";							
						}						
					}
					$session.= "<br />\nEnd of rights<br /><br />\n"; 
					continue;
					unset ($_sess[$key]);
				}
				$session.= "key : $key; Value : $value<br />\n";
			}
	}
	return ( isset($session) ) ? $session : FALSE;
}

function __character_limiter ( $text, $limit ) {
	$CI = & get_instance ();
	$CI->load->helper ( 'text' );
	return character_limiter ( $text, $limit );
}

function file_extension ( $filename ) {
	$path_info = pathinfo ( $filename );
	return $path_info [ 'extension' ];
}

function strip_punctuation ( $text, $alsoStopWords = TRUE ) {
	$CI = &get_instance ();
	$CI->load->library ( 'stopwords' );
	if ( $alsoStopWords ) {
		return $CI->stopwords->parseString ( $text );
	}
	else {
		return $CI->stopwords->removeSymbols ( $text );
	}
}

function get_friendly_time_elapsed ( $value ) {
	$hours = floor ( $value / 3600 );
	$value = $value % 3600;
	
	$minutes = floor ( $value / 60 );
	$value = $value % 60;
	
	$seconds = $value;
	return str_pad ( $hours, 2, '0', STR_PAD_LEFT ) . 'h:' . str_pad ( $minutes, 2, '0', STR_PAD_LEFT ) . 'm:' . str_pad ( $seconds, 2, '0', STR_PAD_LEFT ) . 's';
}

function prepare_tag ( $utf8_text, $replace = array ( ' ' ) ) {
	/* Strip HTML tags */
	$utf8_text = strip_tags ( $utf8_text );
	
	/* Decode HTML entities */
	$utf8_text = html_entity_decode ( $utf8_text, ENT_NOQUOTES );
	
	/* Remove punctuation */
	$utf8_text = strip_punctuation ( $utf8_text );
	
	$search = array ( 
		
		'/\s+/' 
	);
	
	$utf8_text = preg_replace ( $search, $replace, $utf8_text );
	
	return $utf8_text;
}

function add_colors ( $wallpaper_id, $image ) {
	$CI = & get_instance ();
	$CI->load->model ( 'mcolors' );
	
	$colors = get_image_colors ( $image );
	
	if ( is_array ( $colors ) && ! empty ( $colors ) ) {
		foreach ( $colors as $color ) {
			if ( validate_hex ( $color ) ) {
				$color_id = $CI->mcolors->add ( $color );
				$CI->mcolors->add_rel ( $color_id, $wallpaper_id );
			}
		}
	}
}

function validate_hex ( $hex ) {
	return ( @preg_match ( '/[a-f0-9]{6}$/i', $hex ) ) ? TRUE : FALSE;
}

/**
 * Taken from CI, converted to support multibite
 */

function character_limiter ( $str, $n = 500, $end_char = '&#8230;' ) {
	if ( ws_strlen ( $str ) < $n ) {
		return $str;
	}
	
	$str = preg_replace ( "/\s+/", ' ', str_replace ( array ( 
		
		"\r\n", 
		"\r", 
		"\n" 
	), ' ', $str ) );
	
	if ( ws_strlen ( $str ) <= $n ) {
		return $str;
	}
	
	$out = "";
	foreach ( explode ( ' ', trim ( $str ) ) as $val ) {
		$out .= $val . ' ';
		if ( strlen ( $out ) >= $n ) {
			return trim ( $out ) . $end_char;
		}
	}
}

function add_start_end_slashes ( $input ) {
	if ( $input != '' && ( $input != '/' ) ) {
		if ( substr ( $input, - 1 ) != '/' ) {
			$input = $input . '/';
		}
		
		if ( substr ( $input, 0, - ( strlen ( $input ) - 1 ) ) != '/' ) {
			$input = '/' . $input;
		}
		return $input;
	}
}

function get_available_templates () {
	$dirlist = searchdir ( TEMPLATES_DIR, 1 );
	$array = array ();
	foreach ( $dirlist as $dir ) {
		$kt = explode ( '/', $dir );
		if ( $kt [ count ( $kt ) - 2 ] != 'templates' ) {
			array_push ( $array, $kt [ count ( $kt ) - 2 ] );
		}
	}
	return $array;
}

function create_file_name ( $path_to_file ) {
	$CI = &get_instance ();
	$CI->load->library ( 'wb_file_manager' );
	return @md5_file ( $path_to_file ) . '.' . $CI->wb_file_manager->file_extension ( $path_to_file );
}

function check_empty_folder ( $folder ) {
	$files = array ();
	if ( $handle = opendir ( $folder ) ) {
		while ( false !== ( $file = readdir ( $handle ) ) ) {
			if ( $file != "." && $file != ".." ) {
				return FALSE;
			}
		}
		closedir ( $handle );
	}
	return TRUE;
}

function do_xhtml ( $string ) {
	$string = stripslashes ( $string );
	$string = str_replace ( "'", "&#039;", $string );
	$string = str_replace ( '"', '&quot;', $string );
	$string = str_replace ( '`', '', $string );
	$string = str_replace ( '>', '&gt;', $string );
	$string = str_replace ( '<', '&lt;', $string );
	
	return $string;
}

function get_level_access ( $id ) {
	$CI = & get_instance ();
	$CI->load->model ( 'users_model' );
	return $CI->users_model->get_level_access ( $id );
}

function check_allowed_size ( $allowed_sizes, $file, $type = 'w' ) {
	$details = getimagesize ( $file );
	$heights = array ();
	$widths = array ();
	
	foreach ( $allowed_sizes as $key => $value ) {
		foreach ( $value as $height => $width ) {
			$heights [] = $height;
			$widths [] = $width;
		}
	}
	return ( $type == 'w' ) ? ( ( isset ( $details [ 0 ] ) && in_array ( $details [ 0 ], array_values ( $widths ) ) ) ? TRUE : FALSE ) : ( ( isset ( $details [ 1 ] ) && in_array ( $details [ 1 ], array_values ( $heights ) ) ) ? TRUE : FALSE );
}

function check_wide ( $file ) {
	$details = getimagesize ( $file );
	$heights = array ();
	$widths = array ();
	
	foreach ( get_sizes () as $height => $width ) {
		if ( isset ( $details [ 0 ] ) && isset ( $details [ 1 ] ) && $details [ 0 ] == $width && $details [ 1 ] == $height && round ( $width / $height ) == 2 ) {
			return TRUE;
		}
	}
	return FALSE;
}

function get_sizes ( $type = FALSE ) {
	$normal = array ( 
		
		1920 => 2560, 
		1440 => 1920, 
		1260 => 1680, 
		1200 => 1600, 
		1024 => 1280, 
		960 => 1280, 
		864 => 1152, 
		768 => 1024, 
		600 => 800 
	);
	$wide = array ( 
		
		1600 => 2560, 
		1200 => 1920, 
		1050 => 1680, 
		900 => 1440, 
		800 => 1280 
	);
	$psp = array ( 
		
		272 => 480 
	);
	$iphone = array ( 
		
		480 => 320 
	);
	$hd = array ( 
		
		1080 => 1920, 
		768 => 1366, 
		720 => 1280, 
		480 => 852 
	);
	$multi = array ( 
		
		1536 => 4096, 
		1200 => 3840, 
		1050 => 3360, 
		1200 => 3200, 
		900 => 2880, 
		1050 => 2800, 
		960 => 2560, 
		864 => 2304, 
		768 => 2048, 
		625 => 2000 
	);
	
	if ( $type != FALSE ) {
		switch ( $type ) {
			case 'normal' :
				return $normal;
				break;
			case 'wide' :
				return $wide;
				break;
			case 'psp' :
				return $psp;
				break;
			case 'iphone' :
				return $iphone;
				break;
			case 'hd' :
				return $hd;
				break;
			case 'multi' :
				return $multi;
				break;
		}
	}
	elseif ( ! $type ) {
		return array ( 
			'normal' => $normal, 
			'wide' => $wide, 
			'psp' => $psp, 
			'iphone' => $iphone, 
			'hd' => $hd, 
			'multi' => $multi 
		);
	}
	return array ();
}

function is_normal ( $h, $w ) {
	$sizes = get_sizes ( 'normal' );
	return ( isset ( $sizes [ $h ] ) && $sizes [ $h ] == $w ) ? TRUE : FALSE;
}

function is_wide ( $h, $w ) {
	$sizes = get_sizes ( 'wide' );
	return ( isset ( $sizes [ $h ] ) && $sizes [ $h ] == $w ) ? TRUE : FALSE;
}

function is_psp ( $h, $w ) {
	return ( $h == 272 && $w == 480 ) ? TRUE : FALSE;
}

function is_iphone ( $h, $w ) {
	return ( $h == 480 && $w == 320 ) ? TRUE : FALSE;
}

function is_hd ( $h, $w ) {
	$sizes = get_sizes ( 'hd' );
	return ( isset ( $sizes [ $h ] ) && $sizes [ $h ] == $w ) ? TRUE : FALSE;
}

function is_multi ( $h, $w ) {
	$sizes = $sizes = get_sizes ( 'multi' );
	return ( isset ( $sizes [ $h ] ) && $sizes [ $h ] == $w ) ? TRUE : FALSE;
}

function detect_wallpaper_type ( $sizes, $h, $w ) {
	if ( is_iphone ( $h, $w ) ) {
		return 'iphone';
	}
	if ( is_psp ( $h, $w ) ) {
		return 'psp';
	}
	if ( is_hd ( $h, $w ) ) {
		return 'hd';
	}
	if ( is_multi ( $h, $w ) ) {
		return 'multi';
	}
	if ( is_wide ( $h, $w ) ) {
		return 'wide';
	}
	if ( is_normal ( $h, $w ) ) {
		return 'normal';
	}
	return 'other';
}

function get_lower_sizes ( $original_width, $type ) {
	$out = array ();
	
	foreach ( get_sizes ( $type ) as $height => $width ) {
		if ( $width < $original_width ) {
			$out [ $height ] = $width;
		}
	}
	
	ksort ( $out );
	return $out;
}

function get_lowest_sizes ( $sizes, $type ) {
	$wide = array ();
	$normal = array ();
	
	$new_width = 100000;
	
	foreach ( $sizes as $size ) {
		foreach ( $size as $height => $width ) {
			if ( round ( $width / $height ) == 2 ) { //wide
				if ( $width < $new_width ) {
					$wide = array ( 
						
						$height, 
						$width 
					);
				}
			}
			elseif ( round ( $width / $height ) == 1 ) { //normal
				if ( $width < $new_width ) {
					$normal = array ( 
						
						$height, 
						$width 
					);
				}
			}
		}
	}
	
	switch ( $type ) {
		case 'normal' :
			return $normal;
			break;
		
		case 'wide' :
			return $wide;
			break;
	}
}

function ByteSize ( $file_size ) {
	$file_size = $file_size - 1;
	if ( $file_size >= 1099511627776 )
		$show_filesize = number_format ( ( $file_size / 1099511627776 ), 2 ) . " TB";
	elseif ( $file_size >= 1073741824 )
		$show_filesize = number_format ( ( $file_size / 1073741824 ), 2 ) . " GB";
	elseif ( $file_size >= 1048576 )
		$show_filesize = number_format ( ( $file_size / 1048576 ), 2 ) . " MB";
	elseif ( $file_size >= 1024 )
		$show_filesize = number_format ( ( $file_size / 1024 ), 2 ) . " KB";
	elseif ( $file_size > 0 )
		$show_filesize = $file_size . " b";
	elseif ( $file_size == 0 || $file_size == - 1 )
		$show_filesize = "0 b";
	return $show_filesize;
}

function create_images_path () {
	return base_url () . 'assets/' . DEFAULT_TEMPLATE . '/images/';
}

function selfURL () {
	$s = empty ( $_SERVER [ "HTTPS" ] ) ? '' : ( $_SERVER [ "HTTPS" ] == "on" ) ? "s" : "";
	$protocol = strleft ( strtolower ( $_SERVER [ "SERVER_PROTOCOL" ] ), "/" ) . $s;
	$port = ( $_SERVER [ "SERVER_PORT" ] == "80" ) ? "" : ( ":" . $_SERVER [ "SERVER_PORT" ] );
	return $protocol . "://" . $_SERVER [ 'HTTP_HOST' ] . $port . $_SERVER [ 'REQUEST_URI' ];
}

function strleft ( $s1, $s2 ) {
	return substr ( $s1, 0, strpos ( $s1, $s2 ) );
}

function evaluate_response ( $reponse ) {
	$arr = explode ( '|', $reponse );
	
	switch ( $arr [ 0 ] ) {
		case 'error' :
			return '<div class="info_messages error"><div class="inner">' . $arr [ 1 ] . '</div></div>' . "\n";
			break;
		
		case 'ok' :
			return '<div class="info_messages success"><div class="inner">' . $arr [ 1 ] . '</div></div>' . "\n";
			break;
		
		case 'notice' :
			return '<div class="info_messages notice"><div class="inner">' . $arr [ 1 ] . '</div></div>' . "\n";
			break;
		
		default :
			return '<div class="info_messages info"><div class="inner">' . $arr [ 1 ] . '</div></div>' . "\n";
	}
}

function qstr ( $str, $magic_quotes = false ) {
	switch ( gettype ( $str ) ) {
		case 'string' :
			$replaceQuote = "\\'"; /// string to use to replace quotes
			if ( ! $magic_quotes ) {
				
				if ( $replaceQuote [ 0 ] == '\\' ) {
					// only since php 4.0.5
					$str = _str_replace ( array ( 
						
						'\\', 
						"\0" 
					), array ( 
						
						'\\\\', 
						"\\\0" 
					), $str );
					//$s = str_replace("\0","\\\0", str_replace('\\','\\\\',$s));
				}
				return "'" . str_replace ( "'", $replaceQuote, $str ) . "'";
			}
			
			// undo magic quotes for "
			$str = str_replace ( '\\"', '"', $str );
			
			if ( $replaceQuote == "\\'" ) { // ' already quoted, no need to change anything
				return "'$str'";
			}
			else { // change \' to '' for sybase/mssql
				$str = str_replace ( '\\\\', '\\', $str );
				return "'" . str_replace ( "\\'", $treplaceQuote, $str ) . "'";
			}
			break;
		case 'boolean' :
			$str = ( $str === FALSE ) ? 0 : 1;
			return $str;
			break;
		case 'integer' :
			$str = ( $str === NULL ) ? 'NULL' : $str;
			return $str;
			break;
		default :
			$str = ( $str === NULL ) ? 'NULL' : $str;
			return $str;
			break;
	}
}

function escape_arr ( $array ) {
	if ( is_array ( $array ) ) {
		foreach ( $array as $key => $value ) {
			$new_arr [ $key ] = addslashes ( $value );
		}
		return $new_arr;
	}
}

function _str_replace ( $src, $dest, $data ) {
	if ( is_php('5.0.0') )
		return str_replace ( $src, $dest, $data );
	
	$s = reset ( $src );
	$d = reset ( $dest );
	while ( $s !== false ) {
		$data = str_replace ( $s, $d, $data );
		$s = next ( $src );
		$d = next ( $dest );
	}
	return $data;
}

function send_email ( $subject, $to, $body, $replyto = FALSE ) {
	$CI = &get_instance ();
	$CI->load->library ( 'phpmailer' );
	//do we use SMTP?
	if ( USE_SMTP ) {
		$CI->phpmailer->IsSMTP ();
		$CI->phpmailer->SMTPAuth = true;
		$CI->phpmailer->Host = SMTP_HOST;
		$CI->phpmailer->Port = SMTP_PORT;
		$CI->phpmailer->Password = SMTP_PASS;
		$CI->phpmailer->Username = SMTP_USER;
	}
	
	$CI->phpmailer->From = ADMIN_EMAIL;
	$CI->phpmailer->FromName = DOMAIN_NAME;
	$CI->phpmailer->AddAddress ( $to );
	if ( $replyto != FALSE ) {
		$CI->phpmailer->AddReplyTo ( $replyto );
	}
	else {
		$CI->phpmailer->AddReplyTo ( ADMIN_EMAIL, DOMAIN_NAME );
	}
	$CI->phpmailer->Subject = $subject;
	$CI->phpmailer->Body = $body;
	$CI->phpmailer->WordWrap = 100;
	$CI->phpmailer->IsHTML ( MAIL_IS_HTML );
	$CI->phpmailer->AltBody = html2txt ( $body );
	$CI->phpmailer->CharSet = "UTF-8";
	
	if ( ! $CI->phpmailer->Send () ) {
		return FALSE;
	}
	else {
		$CI->phpmailer->ClearAllRecipients ();
		$CI->phpmailer->ClearReplyTos ();
		return TRUE;
	}
}

function html2txt ( $text ) {
	return strip_tags ( $text );
}

function valid_email ( $str ) {
	return ( ! preg_match ( "/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $str ) ) ? FALSE : TRUE;
}

function valid_ip ( $ip ) {
	return $this->CI->valid_ip ( $ip );
}

function alpha ( $str ) {
	return ( ! preg_match ( "/^([a-z])+$/i", $str ) ) ? FALSE : TRUE;
}

function alpha_numeric ( $str ) {
	return ( ! preg_match ( "/^([a-z0-9])+$/i", $str ) ) ? FALSE : TRUE;
}

function alpha_dash ( $str ) {
	return ( ! preg_match ( "/^([-a-z0-9_-])+$/i", $str ) ) ? FALSE : TRUE;
}

function numeric ( $str ) {
	return ( ! preg_match ( "/^[0-9\.]+$/i", $str ) ) ? FALSE : TRUE;
}

function get_uri_segments ( $uri ) {
	$url = parse_url ( $uri );
	$kt = explode ( $url [ 'host' ] . '/', $uri );
	
	$prepare_segments = explode ( '/', $kt [ 1 ] );
	
	$clean_uri = '';
	
	foreach ( $prepare_segments as $value ) {
		if ( $value != '' ) :
			$clean_uri .= $value . '/';
		
			endif;
	}
	
	return ( ! empty ( $clean_uri ) ) ? substr ( $clean_uri, 0, - 1 ) : FALSE;
}

function prepare_constant ( $input, $bolean = FALSE ) {
	return ( $bolean ) ? ( ( $input == 1 ) ? 'TRUE' : 'FALSE' ) : "'" . addslashes ( $input ) . "'";
}

function get_tooltip ( $index, $what = FALSE ) {
	$tooltips = array ( 
		
		'cat_details' => array ( 
			
			'title' => Lang ( 'cat_details_title' ), 
			'content' => Lang ( 'cat_details' ) 
		), 
		'manage_subcats' => array ( 
			
			'title' => Lang ( 'manage_subcats_title' ), 
			'content' => Lang ( 'manage_subcats' ) 
		), 
		'cat_group_perm' => array ( 
			
			'title' => Lang ( 'cat_group_perm_title' ), 
			'content' => Lang ( 'cat_group_perm' ) 
		), 
		'lock_cat' => array ( 
			
			'title' => Lang ( 'lock_cat_title' ), 
			'content' => Lang ( 'lock_cat' ) 
		), 
		'delete_cat' => array ( 
			
			'title' => Lang ( 'delete_cat_title' ), 
			'content' => Lang ( 'delete_cat' ) 
		), 
		'unlock_cat' => array ( 
			
			'title' => Lang ( 'unlock_cat_title' ), 
			'content' => Lang ( 'unlock_cat' ) 
		) 
	);
	
	if ( isset ( $tooltips [ $index ] [ $what ] ) && $tooltips [ $index ] [ $what ] != '' && TOOLTIPS_ENABLED ) {
		return $tooltips [ $index ] [ $what ];
	}
	return FALSE;
}

function __img_text ( $text, $text_color = 'FFFFFF', $size = 10, $font = 'AlteHaasGroteskBold' ) {
	return '<img src="' . APPLICATION_URL . 'scripts/buttons.php?text=' . base64_encode ( $text ) . '&amp;size=' . $size . '&amp;font=' . $font . '&amp;color=' . $text_color . '" alt="' . str_replace ( '"', '', $text ) . '" />';
}
//manage a many sessions on templates views
function session_flashdata ( $str ) {
	$CI = &get_instance ();
	$myflashdata=$CI->session->userdata($str);
	$CI->session->set_userdata($str, null);//session empty
	return $myflashdata;
}

//helper lang for templates modules using
function module_lang ( $line, $modul_lang ) {
	$CI = &get_instance ();
	return $CI->lang->line($line, $modul_lang);
}
//helper code lang for templates modules using  en,fr,es,it ...
function code_lang () {
	$CI = &get_instance ();
	return $CI->session->userdata('code_language');
}

function all_language () {
	$CI = &get_instance ();
	if ( !class_exists('Languages_model')) $CI->load->model('languages_model');
	$row = $CI->languages_model->getAllLang ();
	return $row;
}

function getlangByCode ($args=array('code'=>'en')) {
	$CI = &get_instance ();
	if ( !class_exists('Languages_model')) $CI->load->model('languages_model');
	$row = $CI->languages_model->getLang($args)->row_array();
	return $row['name'];
}

function getCodeBylang ($args=array('language'=>'english')) {
	$CI = &get_instance ();
	if ( !class_exists('Languages_model')) $CI->load->model('languages_model');
	$row = $CI->languages_model->getLang($args)->row_array();
	return $row['code'];
}

function get_slides($category){

   $CI = &get_instance ();
	$CI->load->model ( 'photos_model' );
	return $CI->photos_model->getPhotos ($category  );
}

function get_links($category){

   $CI = &get_instance ();
	$CI->load->model ( 'links_model' );
	return $CI->links_model->getLinks($category  );
}

function get_posts($category){

   $CI = &get_instance ();
	$CI->load->model ( 'posts_model' );
	return $CI->posts_model->getPosts($category  );
}

function file_icon($file_ext){
		if(in_array($file_ext, array('flv','mpg','wmv','avi')))
			return 'film.png';
		if(in_array($file_ext, array('jpg','jpeg','png','gif')))
			return 'picture.png';
		if(in_array($file_ext, array('mp3','mp4','wav')))
			return 'music.png';
		if(in_array($file_ext, array('pdf')))
			return 'page_white_acrobat.png';
		if(in_array($file_ext, array('db','sql')))
			return 'page_white_database.png';
		if(in_array($file_ext, array('xls','xlsx')))
			return 'page_white_excel.png';
		if(in_array($file_ext, array('ini','dll')))
			return 'page_white_gear.png';
		if(in_array($file_ext, array('ppt','pptx')))
			return 'page_white_powerpoint.png';
		if(in_array($file_ext, array('doc','docx')))
			return 'page_white_word.png';
		if(in_array($file_ext, array('html','htm','lnk')))
			return 'page_white_world.png';
		if(in_array($file_ext, array('zip')))
			return 'page_white_zip.png';
		if(in_array($file_ext, array('txt','text','rtf')))
			return 'page_white_text.png';
		return 'page_white.png';

	}
	
function module_data(){
		$CI = &get_instance ();
		$CI->load->model ('modules_model');
		$modules['visible']=$CI->modules_model->getVisible();
		$modules['installed']=$CI->modules_model->countModules('installed');
		$modules['notinstalled']=$CI->modules_model->countModules('uninstalled');
		return $modules;
	}
    
/**
 * Returns the group items
 *
 * @param array() $group_arg
 * @return str
 */	
function get_group($group_args=NULL){
		
	if(is_array($group_args)){
		$CI = &get_instance ();
		$CI->load->model ('usergroups_model');
		$group_item=$CI->Usergroups_model->get_group($group_args);
	} else { 
		return FALSE;
	}
	return $group_item->row_array();
}
/**
 * retreive of access Right on the users groups
 *
 * subscriber, admin, superadmin
 * 
 * @param none
 * @return boolean
 */	 
function is_subscriber () {
	
	return check_subscriber();
}

function is_admin () {
	
	return check_admin();
}

function is_superadmin () {
	
	return check_Superadmin();
}

function UserAccessRight($module='dashboard', $right='canView'){
	
	$CI = &get_instance ();
	$UserAccessRight=array();
	$UserAccessRight = $CI->session->userdata('user_access_right');

	if( ! $UserAccessRight[$module][$right] ){
		return FALSE;
	}else{
	   return TRUE;
	}
}
/**
 * manage of access Right on the VIEWS
 *
 * canView, canEdit, canDelete
 * 
 * @param str $module
 * @return boolean
 */	 
function canView($module='pages') {
	
	return $this->canView($module);
}

function canEdit($module='pages') {
	
	return $this->canEdit($module);
}

function canDelete($module='pages') {
	
	return $this->canDelete($module);
}

/* End of file function_helper.php */
/* Location: ./application/helpers/function_helper.php */
