<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/* 
	File: twitter.php
	
	Description:
		The following class is for using twitter.com
		
		This class was based off the work of Antonio Lupetti. Original Work can be found at:
			http://woork.blogspot.com/2007/10/twitter-send-message-from-php-page.html
	
	Contributing Author( s): 
		Antonio Lupetti < antonio.lupetti@gmail.com >
		Scott Sloan < scott@aimclear.com > 
		
	Date: January 4th, 2008
	License: Creative Commons
	
*/
class CI_Twitter {
	
	private $user;
	private $pass;
	private $ch;
	private $twitterHost = "http://twitter.com/";
	
	public function __construct($params) {
		$this->user = $params['user'];
		$this->pass = $params['pass'];
		
		/* Create and setup  the curl Session */
		$this->ch = curl_init();
	
		curl_setopt($this->ch, CURLOPT_VERBOSE, 1);
		curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($this->ch, CURLOPT_USERPWD, "$this->user:$this->pass");
		curl_setopt($this->ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
		
	}
	
	public function __destruct() {
		/*clean Up */
		curl_close($this->ch);
	}

	public function setStatus($stat) {
		if(strlen($stat) < 1)
			return false; 
		
		/*Set the host information for the curl session */
		$this->twitterHost .= "statuses/update.xml?status=". urlencode(stripslashes(urldecode($stat)));
		curl_setopt($this->ch, CURLOPT_POST, 1);
		curl_setopt($this->ch, CURLOPT_URL, $this->twitterHost);
		
		/* Execute and get the http code to see if it was succesfull or not*/
		$result = curl_exec($this->ch);	
		$resultArray = curl_getinfo($this->ch);
				
		if ($resultArray['http_code'] == 200){
			
			$objXML = new xml2Array();
 			$arrOutput = $objXML->parse($result);
 			//print_r($arrOutput[0]); 
			return $arrOutput[0][children][1][tagData];
			
		}
		return false;
	}
	
	public function getStatus() {
		/*Set the host information for the curl session */
		$this->twitterHost .= "statuses/user_timeline.xml";
		//http://twitter.com/statuses/user_timeline.format
		curl_setopt($this->ch, CURLOPT_GET, 1);
		curl_setopt($this->ch, CURLOPT_URL, $this->twitterHost);
		
		/* Execute and get the http code to see if it was succesfull or not*/
		$result = curl_exec($this->ch);	
		$resultArray = curl_getinfo($this->ch);
		
		if ($resultArray['http_code'] == 200){
			
			$objXML = new xml2Array();
 			$arrOutput = $objXML->parse($result);
 			//print_r($arrOutput[0]); 
			return $arrOutput;
			
		}
			
		return false;
	}
	
	public function destroy($id) {
		if(strlen($id) < 1)
			return false; 
		
		/*Set the host information for the curl session */
		$this->twitterHost .= "statuses/destroy/$id.xml";
		
		curl_setopt($this->ch, CURLOPT_URL, $this->twitterHost);
		
		/* Execute and get the http code to see if it was succesfull or not*/
		$result = curl_exec($this->ch);	
		$resultArray = curl_getinfo($this->ch);
				
		if ($resultArray['http_code'] == 200)
				return true;
		else 		
				return false;
	}
	
}


class xml2Array {
   
    var $arrOutput = array();
    var $resParser;
    var $strXmlData;
   
    function parse($strInputXML) {
   
            $this->resParser = xml_parser_create ();
            xml_set_object($this->resParser,$this);
            xml_set_element_handler($this->resParser, "tagOpen", "tagClosed");
           
            xml_set_character_data_handler($this->resParser, "tagData");
       
            $this->strXmlData = xml_parse($this->resParser,$strInputXML );
            if(!$this->strXmlData) {
               die(sprintf("XML error: %s at line %d",
            xml_error_string(xml_get_error_code($this->resParser)),
            xml_get_current_line_number($this->resParser)));
            }
                           
            xml_parser_free($this->resParser);
           
            return $this->arrOutput;
    }
    function tagOpen($parser, $name, $attrs) {
       $tag=array("name"=>$name,"attrs"=>$attrs);
       array_push($this->arrOutput,$tag);
    }
   
    function tagData($parser, $tagData) {
       if(trim($tagData)) {
            if(isset($this->arrOutput[count($this->arrOutput)-1]['tagData'])) {
                $this->arrOutput[count($this->arrOutput)-1]['tagData'] .= $tagData;
            }
            else {
                $this->arrOutput[count($this->arrOutput)-1]['tagData'] = $tagData;
            }
       }
    }
   
    function tagClosed($parser, $name) {
       $this->arrOutput[count($this->arrOutput)-2]['children'][] = $this->arrOutput[count($this->arrOutput)-1];
       array_pop($this->arrOutput);
    }
}

