<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Items_model extends MY_Model{
// `" . $this->db->dbprefix($this->table_itemsw) . "`
 
    public $table_items = 'items';
    public $table_itemsw = 'items_view'; 
    public $table_cat = 'categories';
    public $table_users	= 'users';    
    public $table_items_img	= 'item_images';
    public $table_items_siz	= 'item_sizes';
    	
	function __construct(){
		parent::__construct();
		$this->module = 'items';		
		$this->photo_upload_path = $this->Users_model->getOption('file_upload_path').'items/';
		$this->image_allowed_types = $this->Users_model->getOption('image_allowed_types');
	}
	
	function getMerch($id=null, $offset=0, $per_page=100){
		if($id == null)
			return $this->db->query("SELECT * FROM `" . $this->db->dbprefix($this->table_itemsw) . "` ORDER BY category, title LIMIT $offset, $per_page");
		else 
			return $this->db->get_where($this->db->dbprefix($this->table_itemsw), array('id'=>$id));
	}
	
	function getMerchByCategory($slug){
		return $this->db->query("SELECT * FROM `" . $this->db->dbprefix($this->table_itemsw) . "` WHERE cat_slug='$slug'");
	}
	
	function saveHeader($row){
    	//no id, insert new
    	if(!$row['id']){
    		$this->db->insert(
    			$this->db->dbprefix($this->table_items), 
    			array(
    				'title'=>$row['title'],
    				'shortdesc'=>$row['shortdesc'],
    				'description'=>$row['description'],
    				'extra'=>$row['extra'],
    				'merchid'=>$row['merchid'],
    				'date'=>$row['date'],
    				'category'=>$row['category'],
    				'category2'=>$row['category2']
    			)
    		);
    		
    		$new_id = $this->db->insert_id();
    		
    		//check for orphaned images
    		$this->db->update($this->db->dbprefix($this->table_items_img), array('itemid'=>$new_id), array('itemid'=>0));
    		
    		return $new_id;
    	}
    	//update existing
    	else{
    		
    		$this->db->update($this->db->dbprefix($this->table_items), $row, array('id'=>$row['id']));
    		return $row['id'];
    	}
    }
    
	function saveSize($item_id, $row){
    	if(!$row['id']){
    		$data = array(
    			'size' => $row['size'],
    			'description' => $row['description'],
    			'available' => $row['available'],
    			'price'=> $row['price'],
    			'shipping' => $row['shipping'],
    			'itemid' => $item_id
    		);
    		$this->db->insert($this->db->dbprefix($this->table_items_siz), $data);
    	}
    	else {
    		$this->db->update($this->db->dbprefix($this->table_items_siz), $row, array('id'=>$row['id']));
    	}
    }
    
    /**
     * Delete an item and it's sizes and images.
     *
     * @param int $merch_id
     */
    function delete($item_id){
    	//delete sizes
    	foreach($this->getSizes($item_id)->result_array() as $row)
    		$this->deleteSize($row['id']);
    	
    	//delete images
    	foreach($this->getImages($item_id)->result_array() as $row)
    		$this->deleteImage($row['id']);
    		
    	//delete merch data
    	$this->db->delete($this->db->dbprefix($this->table_items), array('id'=>$item_id));
    }
    
    function search($search_str){
    	return $this->db->query("SELECT * FROM `" . $this->db->dbprefix($this->table_items) . "`
    		WHERE MATCH (title,shortdesc,description,extra) AGAINST ('$search_str')");
    }
    
    function countMerch(){
    	return $this->db->count_all($this->db->dbprefix($this->table_items));
    }
    
    
	function getSizes($merch_id){
		return $this->db->get_where($this->db->dbprefix($this->table_items_siz), array('itemid'=>$merch_id));
	}
	
	function getSize($size_id){
		return $this->db->get_where($this->db->dbprefix($this->table_items_siz), array('id'=>$size_id));
	}
	
	function getAllSizes($category_slug=null){
		$data['inventory'] = "<style type='text/css'>body{ font-family: arial}</style>";
		$sizes = $this->db->query("SELECT DISTINCT (size)
					FROM `" . $this->db->dbprefix($this->table_items_siz) . "` s
					JOIN `" . $this->db->dbprefix($this->table_itemsw) . "` m ON s.itemid = m.id
					WHERE m.cat_slug LIKE '$category_slug'");

		$data['inventory'] .= "<table cellspacing=0 cellpadding=10 style='border: 1px solid black;' width='100%'>";
		$data['inventory'] .= "<tr><td colspan=3 style='font-size: 24px; background-color: #555555; color: #ffffff;'><b>The Action! Items Inventory</b></td>";
		foreach($sizes->result_array() as $row){
			if($row['size'] == null) $data['inventory'] .= "<td style=' background-color: #555555; color: #ffffff;'><i>None</i></td>";
			else $data['inventory'] .= "<td style=' background-color: #555555; color: #ffffff;'>$row[size]</td>";
		}
		
		//echo '<pre>';
		$data['inventory'] .= "<td style=' background-color: #555555; color: #ffffff;'><b>Total</b></td></tr>";
		foreach($this->db->query("SELECT * FROM `" . $this->db->dbprefix($this->table_itemsw) . "` WHERE cat_slug LIKE '$category_slug' ORDER BY category, title, shortdesc")->result_array() as $row){
			$data['inventory'] .= "<tr><td style='border-bottom: 1px solid black;'><img src='".base_url()."assets/upload/items/$row[imageid]-mini.$row[filetype]' width=50></td>
				<td style='border-bottom: 1px solid black;'><b>$row[title]</b><br/>$row[shortdesc]</td>
				<td valign='bottom' align='right' style='border-bottom: 1px solid black; font-size: 10px;'>Qty. Sold:</td>";
			$total = 0;
			foreach($sizes->result_array() as $size){
				$size_row = $this->db->get_where($this->db->dbprefix($this->table_items_siz), array('itemid'=>$row['id'], 'size'=>$size['size']))->result_array();

				if( !$size_row ){	
					$size_row[0]['available'] = 0;
				} 
				$data['inventory'] .= "<td style='border-bottom: 1px solid black; border-left: 1px solid gray;' align='center' valign='top'>
					<div style='padding-bottom: 5px; border-bottom: 1px solid gray'>{$size_row[0]['available']}&nbsp;</div></td>";
				$total += $size_row[0]['available'];

				//print_r($size);
			}
			$data['inventory'] .= "<td style='border-bottom: 1px solid black; border-left: 1px solid gray; text-align: right;' valign='top'>
				<div style='padding-bottom: 5px; border-bottom: 1px solid gray'><b>$total</b></div></td></tr>";
		}
		$data['inventory'] .= '</table>';

		return $data['inventory'];
	}
	
	function deleteSize($size_id){
		$this->db->delete($this->db->dbprefix($this->table_items_siz), array('id'=>$size_id));
	}
	
	function getImages($id){
		return $this->db->get_where($this->db->dbprefix($this->table_items_img), array('itemid'=>$id));
	}
	
	function deleteImage($image_id){
		//get event info
		$result = $this->db->get_where($this->db->dbprefix($this->table_items_img), array('id'=>$image_id));
		$row = $result->first_row('array');
		
		//delete event info
		$this->db->delete($this->db->dbprefix($this->table_items_img), array('id'=>$image_id));
		//$deleted_rows = $this->db->affected_rows();
		
		//delete image(s)
		if(file_exists($this->photo_upload_path . $row['imageid']. $row['filetype']))
			unlink($this->photo_upload_path . $row['imageid']. $row['filetype']);
		if(file_exists($this->photo_upload_path . $row['imageid']. '-mini.jpg'.$row['filetype']))
			unlink($this->photo_upload_path . $row['imageid']. 'mini'.$row['filetype']);
		if(file_exists($this->photo_upload_path . $row['imageid']. '-midle'.$row['filetype']))
			unlink($this->photo_upload_path . $row['imageid']. '-midle'.$row['filetype']);
		
		//return array('message'=>$deleted_rows . ' event deleted.');
	}
	
	function setDefaultImage($merch_id, $image_id){
		
		$this->db->update($this->table_items_img, array('main'=>'false'), array('itemid'=>$merch_id));
		
		$this->db->update($this->table_items_img, array('main'=>'true'), array('id'=>$image_id));
	}
	
	function uploadImage($merch_id){
		echo "<pre>";
		print_r($_FILES);
		echo "</pre>";
		
		$upload_path = 	$this->photo_upload_path;	
		$this->load->library('upload', array('upload_path'=>$upload_path,'allowed_types'=>$this->image_allowed_types));	
		$this->load->library('image_lib');

		foreach($_FILES as $field=>$data){
			if($data['name'] == null || $data['error'])
				break;
			
			if(!$this->upload->do_upload($field)){
				$message .= '<br/>' . $this->upload->display_errors();
				break;
			}
			
			$upload_data = $this->upload->data();
			echo "<pre>"; print_r($upload_data); echo "<pre>";
			//save img name to db
			$db_data = array(
				'itemid' => $merch_id,
				'filename' => strtolower($upload_data['raw_name']),
				'filetype' => strtolower(substr($upload_data['file_ext'], 1)),
				'imageid' => strtolower($upload_data['raw_name']),
				'size' => $upload_data['file_size'],
				'date' => time()
				//'imagesize' => $upload_data['image_width'] . 'x' . $upload_data['image_height']
			);
			
			//filename to lower case
			$new_filename = strtolower($upload_data['file_name']);
			rename($upload_path . $upload_data['file_name'], $upload_path . $new_filename);

			$this->db->insert($this->table_items_img, $db_data);
			
			$this->createThumb($new_filename);
			$this->createThumb($new_filename, 640, 480, '-midle');
			
		}
		echo $message;
	}
	
	function createThumb($file_name, $width=200, $height=150, $thumb_marker='-mini'){
		$config['image_library'] = 'gd2';
		$config['source_image'] = $this->photo_upload_path . $file_name;
		$config['create_thumb'] = TRUE;
		$config['maintain_ratio'] = TRUE;
		$config['width'] = $width;
		$config['height'] = $height;
		$config['thumb_marker'] = $thumb_marker;
		
		$this->image_lib->initialize($config); 
		$this->image_lib->resize();
		$this->image_lib->clear();
	}
	
}
