<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

 class Languages_model extends MY_Model{
	 
	public $name;
	public $code;
	private $is_default;
	public  $code_lang;
	public  $active_lang;
	public  $default_lang;
		 
    public $table_lang 	= 'languages';
	
	function __construct(){
		parent::__construct();
	}

	function get( $name='english' ){
		
		$this->db->where('name', $name);

		$query = $this->db->get($this->db->dbprefix($this->table_lang));
		return $query->row();
	}

	
	/**
	 * Save or insert a lang
	 *
	 * @param int $lang_id
	 * @return string
	 */
	function save($lang_id){

		unset($_POST['load']);
		if($lang_id == NULL || $llang_id == 0)
			return $this->db->insert($this->db->dbprefix($this->table_lang), $_POST);
		else 
			return $this->db->update($this->db->dbprefix($this->table_lang), $_POST, array('id'=>$lang_id));
	}
	
	/**
	 * Delete a lang
	 *
	 * @param int $lang_id
	 * @return unknown
	 */
	function delete($lang_id){

		//delete the link
			if( $this->db->delete($this->db->dbprefix($this->table_lang), array('id'=>$lang_id)) )
				return TRUE;
			else
				return FALSE;

	}
	
	/**
	 * get a lang by default
	 *
	 * @param 
	 * @return db_Object
	 */
	 	
	public function get_default_language() {
		
		$this->db->where('is_default', 1);
		$query = $this->db->get($this->db->dbprefix($this->table_lang));
		return ($query->num_rows() === 1) ?	$query->row() : NULL;
		
	}
	
	/**
	 * get a lang active now
	 *
	 * @param 
	 * @return db_Object
	 */
	 	
	public function get_active_language() {
		
		$this->db->where('active', 1);
		$query = $this->db->get($this->db->dbprefix($this->table_lang));
		return ($query->num_rows() === 1) ?	$query->row() : NULL;
		
	}
	
	public function makedefault() {
		
		$db_array = array(
		'is_default'	=>	0);
		
		$this->db->where('is_default', 1);
		$this->db->update($this->db->dbprefix($this->table_lang), $db_array);
				
		$db_array = array(
		'is_default'	=>	1);
		$this->db->where('name', $this->name);
		$this->db->update($this->db->dbprefix($this->table_lang), $db_array);
 
	}
	
	public function makeactivelang() {
		
		$db_array = array(
		'active'	=>	0);
		
		$this->db->where('active', 1);
		$this->db->update($this->db->dbprefix($this->table_lang), $db_array);
				
		$db_array = array(
		'active'	=>	1);
		$this->db->where('name', $this->name);
		$this->db->update($this->db->dbprefix($this->table_lang), $db_array);
 
	}			
	/**
	 * Get a Lang
	 *
	 * 
	 * @param unknown_type $id
	 * @return unknown
	 */
	function getLang($args){
		//lang by id
		if(isset($args['id'])){
			$this->db->where('id', $args['id']);
		}
		
		//lang by code
		if(isset($args['code'])){
			$this->db->where('code', $args['code']);
		}

		//lang  by name
		if(isset($args['language'])){
			$this->db->where('name', $args['language']);
		}
		return $this->db->get($this->db->dbprefix($this->table_lang));
	}
	
	/**
	 * Get All Lang
	 *
	 * @param unknown_type $order
	 * @return unknown
	 */
	function getAllLang($order='name'){
		$q = "SELECT * FROM `" . $this->db->dbprefix($this->table_lang) . "` 
			ORDER BY " . $order;
			$result = $this->db->query($q);
			return $result;
	}
	
	function setLanguage($language_name='english'){

		$language = $this->getLang(array('language'=>$language_name))->row();
		$this->name = $language_name;
		$this->makeactiveLang();
		$this->config->set_item('language', $language->name);// change the default language in config.php
		$this->session->set_userdata('language', $language->name);
		$this->session->set_userdata('code_lang', $language->code);
		return $language;
	}
}

/* End of file languages_model.php */
/* Location: ./application/models/languages_model.php */
