<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Modules_model
 *
 * Candlecms controller.
 * update 2013/01/24  17:10    Melanie LONTSI KENLAK mel.lontsi@gmail.com
 */

class Modules_model extends MY_Model {

    public $table_mod = 'modules';

	public function __construct(){
 		parent::__construct();
 		$this->load->helper('file');
    }




	public function get($args) {

		//module id
		if(isset($args['id'])){
			$this->db->where($this->db->dbprefix($this->table_mod).'.mid', $args['id']);
		}
		if(isset($args['name'])){
			$this->db->where_in('display_name', $args['name']);
		}
		//limit/offset
		if(isset($args['limit'])){
			//$this->db->limit($args['limit'],$args['offset']);
		} else {
			$this->db->limit(100, 0);
		}

		if(isset($args['installed'])){
				$this->db->where($this->db->dbprefix($this->table_mod).'.isinstalled',$args['installed']);
		}
		if(isset($args['visible'])){
			$this->db->where(array("isactive"=>1,"isvisible"=>1));
		}
      $this->db->select("*");
	  $this->db->from($this->db->dbprefix($this->table_mod));

      if(isset($args['count']) && $args['count'] == TRUE){
			return $this->db->count_all_results();
      }
		//order by position in which it's gonna appear
		$this->db->order_by( (!isset($args['order_by'])) ? 'mod_order' : $args['order_by'],'asc' );

		return  $this->db->get();


	}
   /*
    *
    * first installation : files are copy in application/modules
    */
	public function first_install($module){

		$this->load->helper('directory');
		$map = directory_map('application/modules/'.$module);
		$install=file_exists(getcwd().'/application/modules/'.$module.'/config/module_config.php');
		//create tables in database
		if($install) $install=$this->_database($module) ;


		//read configuration file
		if($install ){

		   include(getcwd().'/application/modules/'.$module.'/config/module_config.php');

		   $this->db->select('mod_order');
		   $this->db->order_by('mid','asc');
		   $lastrow=$this->db->get($this->db->dbprefix($this->table_mod));
		   $lastrow=$lastrow->last_row('array');

		   $modular = array(
			   'controller'=>$module_config['controller'],
			   'name'=>$module_config['modular'],
			   'display_name'=>$module_config['display_name'],
			   'version'=>$module_config['version'],
			   'type'=>$module_config['type'],
			   'isinstalled'=>1,
			   'isactive'=>0,
			   'isvisible'=>0,
			   'description'=>$module_config['description'],
			   'icon'=>(isset($module_config['icon'])?$module_config['icon']:''),
			  'mod_order'=>        $lastrow['mod_order']+1

		   );

			$install= $this->db->insert($this->db->dbprefix($this->table_mod),$modular);
			if($install){
			 $this->copy_ressources($module);
			}
		}
		return $install;
	}

	/**
	 *  reinstallation
	 * @param type $id
	 */
	public function install($id) {

		$this->db->where('mid', $id);
		$mod=$this->db->get($this->db->dbprefix($this->table_mod));
		$mod=$mod->row_array();


		$version=str_replace('.','-',$mod['version']);
		$source_path=getcwd().'/assets/uploads/modules/'.$mod['name'].'_'.$version.'.zip';

      if(file_exists($source_path)){
           $this->load->library('unzip');
           $this->unzip->allow('zip');
           $target_dir = getcwd().'/application/modules/';
           $res =$this->unzip->extract($source_path, $target_dir, TRUE);
			if($res){
				$this->db->where('mid', $id);
				$this->db->update($this->db->dbprefix($this->table_mod),array('isinstalled'=>1));
				$this->copy_ressources($mod['name']);
			}
		}
	}

	/*
	delete files from application/modules an set the module as not installed
	*/
	public function uninstall($id) {

		$this->db->where('mid', $id);
		$mod=$this->db->get($this->db->dbprefix($this->table_mod));
		$mod=$mod->row_array();

		if(file_exists(getcwd().'/application/modules/'.$mod['name'] .'/config/'.$mod['name'].'.php'))	{
			include(getcwd().'/application/modules/'.$mod['name'] .'/config/'.$mod['name'].'.php');
			$mod_tables=isset($config['tables'])?$config['tables']:array();
			foreach($mod_tables as $table){
				$query= 'DROP TABLE IF EXISTS `'.$this->db->dbprefix($table).'`';
				$this->db->query($query);
			}
		}


		$res=TRUE;
		chmod(getcwd().'/application/modules/'.$mod['name'] ,0755);
		$res=$res && delete_files(getcwd().'/application/modules/'.$mod['name'] ,TRUE);
		$res=$res && delete_files(getcwd().'/assets/modules/'.$mod['name'] ,TRUE);
		if($res){
			rmdir(getcwd().'/application/modules/'.$mod['name']);
			rmdir(getcwd().'/assets/modules/'.$mod['name']);
			$this->db->where('mid', $id);
			$this->db->update($this->db->dbprefix($this->table_mod),array('isinstalled'=>0,'isactive'=>0,'isvisible'=>0));
		}
		return $res;
	}


	/*
    *
    * delete all ressources from disk
    */

   public function delete($id){
		$this->db->where('mid', $id);
		$mod=$this->db->get($this->db->dbprefix($this->table_mod));
		$mod=$mod->row_array();

		//delete files from assets/modules
		$res=FALSE;
		if($mod['type']!='core'){

			$res=TRUE;
			$version=str_replace('.','-',$mod['version']);
			$zipfile=getcwd().'/assets/uploads/modules/'.$mod['name'].'_'.$version.'.zip';
			
			if(file_exists($zipfile))
					$res=$res && unlink($zipfile);
					
			if($res){
				//delete line in module table
				$this->db->where('mid', $id);
				$this->db->delete($this->db->dbprefix($this->table_mod));
			}
		}
      return $res;
   }


	/**
    *
    * activate/desactivate/visible/invisible
    */
   public function set($id,$value){

       $this->db->where('mid', $id);
       $module=$this->db->get($this->db->dbprefix($this->table_mod))->row_array();

       switch($value){
          case 'able':
             if((int)$module['isinstalled']==1){
                $this->db->where('mid', $id);
                $this->db->update($this->db->dbprefix($this->table_mod),array('isactive'=>1));
                return true;
             }
             else
                return false;
             break;
          case 'disable':
             $this->db->where('mid', $id);
             $this->db->update($this->db->dbprefix($this->table_mod),array('isactive'=>0,'isvisible'=>0));
             return true;
             break;
          case 'visible':
               if((int)$module['isactive']==1){
                $this->db->where('mid', $id);
                $this->db->update($this->db->dbprefix($this->table_mod),array('isvisible'=>1));
                return true;
             }
             else
                return false;
             break;
          case 'invisible':
             $this->db->where('mid', $id);
             $this->db->update($this->db->dbprefix($this->table_mod),array('isvisible'=>0));
             return true;
             break;
       }
   }


			/**
			 * update module from a recent version
			 * @param type $id
			 * @return boolean
			 */
   public function update($id){

			$this->db->where('mid', $id);
			$mod=$this->db->get($this->db->dbprefix($this->table_mod));
			$mod=$mod->row_array();

			if($mod['isinstalled']){

				$install=TRUE;
				$this->load->helper('directory');
				$map = directory_map('application/modules/'.$mod['name']);
				if(file_exists(getcwd().'/application/modules/'.$mod['name'].'/config/module_config.php')) {
					include(getcwd().'/application/modules/'.$mod['name'].'/config/module_config.php');
					if(isset($module_config['new_tables']) && strtolower($module_config['new_tables'])=="yes"){
								$install= $this->_database($mod['name']);
					}

					if($install){
						$this->db->where('mid', $id);
						$install=$this->db->update($this->db->dbprefix($this->table_mod),array('version'=>$module_config['version']));
						$this->copy_ressources($mod['name']);
					}
					return $install;
				}
			}
			else
				return false;
	}

	/**
	 * searching for new modules
  	 * @return boolean  or array
	 */
   public function new_modules(){

		$modules=false;
		$this->load->helper('directory');
		$map = directory_map('application/modules/', TRUE);
      if(isset($map) && count($map)>0){
			foreach ($map AS $module_dir) {
				$module_dir = str_replace( DS, '', $module_dir);// erase the end slashe '/' DS
				if($module_dir!="backoffice" && $module_dir!="forums" && is_dir('application/modules/'.$module_dir)){
					$modules[$module_dir]['name'] = $module_dir;
					$this->db->where('name', $module_dir);
					$query = $this->db->get($this->db->dbprefix($this->table_mod));
					if ($query->num_rows()==0) {
						//first install
						$modules[$module_dir]['to_install']=true;
						$this->first_install($module_dir);
					}
					else{
					   //search for new update
						$query=$query->row_array();
						if($query['isinstalled']){
							include(getcwd().'/application/modules/'.$module_dir.'/config/module_config.php');

							if($query['version'] < $module_config['version'] ){
								$modules[$module_dir]['to_update']= true;
								$modules[$module_dir]['to_version']= $module_config['version'];
							}
						}
					}
				}
			}
			 return $modules;
      }
      else
         return false;

   }

	/**
	 *
	 * @param type $args
	 * @return type
	 */
   public function getModules($args=null){

      $modules=$this->new_modules();

      $allmod = $this->get($args)->result_array();
      if($modules){
         $i=0;
         foreach($allmod as $modular){

            $name=$modular['name'];
            foreach($modules as $cur_mod){
               if($name == $cur_mod['name']){

                  if(isset($cur_mod['to_update']) && $cur_mod['to_update']){
						$allmod[$i]['to_update'] = $cur_mod['to_update'];
						$allmod[$i]['to_version']=$cur_mod['to_version'];

                  }
                  if(isset($cur_mod['to_install']))
                     $allmod[$i]['to_install']=$cur_mod['to_install'];
               }
            }
            $i++;
         }
      }
      return $allmod;
   }
	/*
	 *
	 * return number of modules depending of certain value
	 */
   public function countModules($category='ALL'){

		if($category=='ALL')
			return $this->db->count_all($this->db->dbprefix($this->table_mod));

		$this->db->select("*");
		$this->db->from($this->db->dbprefix($this->table_mod));
		if($category == 'installed'){

			$this->db->where("isinstalled",1);
         return $this->db->count_all_results();
		}
		elseif($category == 'uninstalled'){

			$this->db->where("isinstalled",0);
         return $this->db->count_all_results();
		}
		else  // unknown case
			return 0;

	}
	/**
	 *return visible modules
	 * @return type
	 */
	public function getVisible(){
		$this->db->order_by(  'mod_order' ,'asc' );
		$this->db->where(array("isactive"=>1,"isvisible"=>1));
		return $this->db->get($this->db->dbprefix($this->table_mod));
	}

	/**
	 *update module level
	 * @param type $id
	 * @param type $direction
	 */
	public function move($id,$direction){
		 $this->db->where('mid', $id);
		 $mod=$this->db->get($this->db->dbprefix($this->table_mod))->row_array();

		  if($direction=="up"){ //le module gagne d'un niveau


			$this->db->where('mod_order', ($mod['mod_order']-1));
			$modsup=$this->db->get($this->db->dbprefix($this->table_mod))->row_array();

			$this->db->where('mid', $modsup['mid']);

			$this->db->update($this->db->dbprefix($this->table_mod),array('mod_order'=>($modsup['mod_order'] +1)));

			$this->db->where('mid', $id);
			$this->db->update($this->db->dbprefix($this->table_mod),array('mod_order'=>($mod['mod_order'] - 1)));
			}
			elseif($direction=="down"){ //le module perd d'un niveau
				$this->db->where('mod_order', ($mod['mod_order']+1));
				$modsup=$this->db->get($this->db->dbprefix($this->table_mod))->row_array();

			$this->db->where('mid', $modsup['mid']);

			$this->db->update($this->db->dbprefix($this->table_mod),array('mod_order'=>($modsup['mod_order'] -1)));

			$this->db->where('mid', $id);
			$this->db->update($this->db->dbprefix($this->table_mod),array('mod_order'=>($mod['mod_order'] +1)));

			}
	}

	private function _process_schema($schema){
		// Parse the queries
		$queries 	= explode('-- command split --', $schema);

		foreach($queries as $query)
		{
			$query = rtrim( trim($query), "\n;");

			if(!$this->db->query($query))
			{
				die();
				return FALSE;
			}
		}
		return TRUE;
	}

   private function _database($module){

      $this->load->helper('file');
      $res = TRUE;

      if(file_exists(getcwd().'/application/modules/'.$module.'/sql/tables.sql')) {

         $tables_sql		= file_get_contents(getcwd().'/application/modules/'.$module.'/sql/tables.sql');

		if($tables_sql==FALSE) return FALSE;

		$tables_sql		= str_replace('__DBPREFIX__', 	$this->db->dbprefix, 		$tables_sql);
		$res = $res && $this->_process_schema($tables_sql);
		if( !$res ){
			return FALSE;
		}
		}else
			return FALSE;
			
      // Get the SQL for the default data and parse it
       if(file_exists(getcwd().'/application/modules/'.$module.'/sql/data.sql')) {
			$data_sql		= file_get_contents(getcwd().'/application/modules/'.$module.'/sql/data.sql');

			if( !empty($data_sql) && strlen ( $data_sql ) >10 ){

			$data_sql		= str_replace('__DBPREFIX__', 	$this->db->dbprefix, 		$data_sql);
			$data_sql		= str_replace('INSERT INTO', 	'INSERT IGNORE INTO', 		$data_sql);
			$res = $res && $this->_process_schema($data_sql);

			if( !$res ){
			return FALSE;
			}
         }
      }
      return $res;
   }

	private function copy_ressources($module){

		 if(is_dir(getcwd().'/application/modules/'.$module.'/assets')){
			if(!file_exists(getcwd().'/assets/modules/'.$module)){
				mkdir (getcwd().'/assets/modules/'.$module,0755) ;
			}
			$this->load->helper('install_module');

			copyRep(getcwd().'/application/modules/'.$module.'/assets',getcwd().'/assets/modules/'.$module.'/assets');
			copyRep(getcwd().'/application/modules/'.$module.'/config',getcwd().'/assets/modules/'.$module.'/config');
		}
	}
}
/* End of file modules_model.php */
/* Location: ./application/models/modules_model.php */
