<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Settings_model extends MY_Model {
	
	public $blog_title;
	public $blog_description;
	public $allow_register;
	public $allow_comments;
	public $default_category;
	public $default_page_id;
	public $enabled;
 
    public $table_opts = 'options'; // exemple integrated into SQL  `' . $this->db->dbprefix($this->table) . '`
    public $table_set = 'settings'; 

	
	public function __construct()
	{
		
		parent::__construct();
		
	}
    
    public function getOptions($category){
    	$result = $this->db->get_where($this->db->dbprefix($this->table_opts), array('category'=>$category));
    	
    	foreach($result->result_array() as $row){
    		$data[$row['option_name']] = $row;
    	}
    	
    	$data['view'] = $category;
    	return $data;
    }
    
    public function saveOption($key, $val){
    	$this->db->update($this->db->dbprefix($this->table_opts), array('option_value'=>$val), array('option_name'=>$key));
    }

	
	public function get() {
		
		$this->db->where('setting_id', 1);
		
		$query = $this->db->get($this->db->dbprefix($this->table_set));

		return $query->row();
		
	}
	
	public function save() {
		
		$db_array = array(
		'blog_title'		=>	$this->blog_title,
		'blog_description'	=>	$this->blog_description,
		'allow_register'	=>	$this->allow_register,
		'allow_comments'	=>	$this->allow_comments,
		'default_category'	=>	$this->default_category,
		'default_page_id'	=>	$this->default_page_id,
		'enabled'			=>	$this->enabled
		);
		
		$this->db->where('setting_id', 1);
		
		if ($this->db->update($this->db->dbprefix($this->table_set), $db_array)) {
			
			return TRUE;
			
		}
		
		else {
			
			return FALSE;
			
		}
		
	}
    
}

/* End of file settings_model.php */
/* Location: ./application/models/settings_model.php */
