<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Templates_model extends MY_Model {

	public $template_id;
	public $name;
	public $load_order;
	public $description;
	public $pos_sidebar;
	private $is_default;
  
	
    public $table_tpl = 'templates';
	
	public function __construct(){
 		parent::__construct();
       
    }
    
	public function get() {
		
		$this->load->helper('install_template');
		$this->load->helper('directory');
        $map = directory_map('assets/themes/', TRUE);
		/*
		 * while $template_dir is not backoffice(we are already on the backoffice)
		 * we should get the default template
		 */
		foreach ($map AS $template_dir) {
			
			$template_dir = str_replace( DIRECTORY_SEPARATOR, '', $template_dir);// erase the end slashe '/' DS
			if ($template_dir <> 'backoffice' and $template_dir<> 'reservoir') {
				$templates[$template_dir]['name'] = $template_dir;

				if (file_exists(getcwd() . DIRECTORY_SEPARATOR.'assets'. DIRECTORY_SEPARATOR.'themes'. DIRECTORY_SEPARATOR. $template_dir.DIRECTORY_SEPARATOR.'templates'. DIRECTORY_SEPARATOR.'screenshot.png')) {
					$templates[$template_dir]['screenshot'] = base_url() . 'assets/themes/' . $template_dir . '/templates/screenshot.png';
				}
				else {
					$templates[$template_dir]['screenshot'] = FALSE;
				}
				$this->db->where('name', $template_dir);

				$query = $this->db->get($this->db->dbprefix($this->table_tpl));

				if ($query->num_rows()) {
					$templates[$template_dir]['installed'] = TRUE;
					$tmp_result = $query->row();
					$templates[$template_dir]['template_id']=$tmp_result->template_id;
					if ($tmp_result->is_default) {
						$templates[$template_dir]['is_default'] = TRUE;
					}
				}

				else {
					$templates[$template_dir]['installed'] = FALSE;
				}

				$desc=$this->get_template($template_dir);
				
				if(isset($desc->description))
					  $templates[$template_dir]['description'] =$desc->description;
				else
					$templates[$template_dir]['description'] = '';

					if (include(getcwd() .DIRECTORY_SEPARATOR.'assets'.DIRECTORY_SEPARATOR.'themes'.DIRECTORY_SEPARATOR . $template_dir .DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.'template_config.php')) {

						if (isset($template_config['load_order']) AND isset($template_config['version'])) {
    
						$templates[$template_dir]['compatible'] = TRUE;
						$templates[$template_dir]['version'] = $template_config['version'];
						$templates[$template_dir]['load_order'] = $template_config['load_order'];
						$templates[$template_dir]['pos_sidebar'] = $template_config['sidebar'];           
						$this->load_order=$template_config['load_order'];
						if(!$templates[$template_dir]['installed'])
							 $this->pos_sidebar=$template_config['sidebar'];
 
					}
				}
				else {
					$templates[$template_dir]['compatible'] = FALSE;
				}
          
			}
		}
		return $templates;
	}
	
	public function get_default_template() {
		
		$this->db->where('is_default', 1);
		$query = $this->db->get($this->db->dbprefix($this->table_tpl));
		return $query->row();
		
	}
	
	public function install() {
		
		$db_array = array(
				'name'		=>	$this->name,
				'load_order'=>	$this->load_order,
				'sidebar'	=>	$this->pos_sidebar,
                'description'=>	$this->description
				);
                
		$this->db->insert($this->db->dbprefix($this->table_tpl), $db_array);

		
      $template_file=file_get_contents(getcwd().'/application/config/template.php');
      
      $desc= "

      /* $this->name configuration */
\$template['$this->name']['template'] = 'template';
\$template['$this->name']['regions'] = array('title', 'header',  'content',  'sidebar', 'footer', 'maintenance',	);
\$template['$this->name']['parser'] = 'parser';
\$template['$this->name']['parser_method'] = 'parse';
\$template['$this->name']['parse_template'] = FALSE;
              ";
      
      $test=stristr($template_file, $desc);

      if(empty($test)||$test ==FALSE){

         //the template group has not yet been created in tthe template file config

         $template['template']='template';
        $template['regions']=explode(',',$this->load_order);

         $this->template->add_template($this->name,$template,FALSE);

         $file=fopen(getcwd().'/application/config/template.php','a+');
         fputs($file,$desc);
         fclose($file);

      }
	}
	
	public function uninstall() {

		$this->db->where('template_id', $this->template_id);
		$this->db->delete($this->db->dbprefix($this->table_tpl));

		$this->load->helper('file');
		//delete files in assets/themes
		delete_files(getcwd().'/assets/themes/'.$this->name.'/',TRUE);
		rmdir(getcwd().'/assets/themes/'.$this->name.'/');
		//delete files in application/views/themes
		delete_files(getcwd().'/application/views/themes/'.$this->name.'/',TRUE);
		rmdir(getcwd().'/application/views/themes/'.$this->name.'/');

        //NOW HAVE TO DELETE CONFIGURATIONS DETAILS IN config/template.php

	}
	
	public function makedefault() {
		
		$db_array = array(
		'is_default'	=>	0);
		
		$this->db->where('is_default', 1);
		$this->db->update($this->db->dbprefix($this->table_tpl), $db_array);
		
		$db_array = array(
		'is_default'	=>	1);
		
		$this->db->where('name', $this->name);
		$this->db->update($this->db->dbprefix($this->table_tpl), $db_array);
 
	}

	public function get_template($name){
		$this->db->where('name', $name);

		$query = $this->db->get($this->db->dbprefix($this->table_tpl));
		return $query->row();

	}

}
/* End of file Templates_model.php */
/* Location: ./application/models/Templates_model.php */
