<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Users_model
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/03  17:10   gabriel gbobard@gmail.com
 */
//include 'usergroups_model.php';
  
class Users_model extends MY_Model {

	public $salt;

	public $salt_length;
	public $user_level;
	public $active;
   
   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * remarque: un champs doit etre creer dans la table pour stocker cette
   * id du groupe
   * comment:
   * id groupe, pour retrouver le groupe auquel appartient le user
   * au final elle pourait  remplacer le user level
   *
   */
 
    public $table_users = 'users'; 
    public $table_users_log = 'user_logins'; 
    public $table_groups = 'groups';
    public $table_modules ='modules';
    		
	public function __construct()
	{
		parent::__construct();

		$this->registered = time();
		$this->active = 1;
		$this->salt_length = 5;
		$this->user_level = 6;
		$this->limit = 20;
		$this->user_salt = $this->salt();

      $this->load->model('Usergroups_model');
		
	}

	public function get_users( $args ) {

		$this->_prep_query($args);
		$query = $this->db->get($this->db->dbprefix($this->table_users));
		return ($query->num_rows()) ? $query : FALSE;
	}

	private function _prep_query( $args=NULL ) {

		// query user

		if (isset($args['user_id'])) {
			$this->db->where('user_id', $args['user_id']);
		}

		if (isset($args['user_level'])) {
			$this->db->where('user_level <> ', $args['user_level']);
		}

		if (isset($args['email_address']) && $args['email_address'] && isset($args['password']) && $args['password']) {
			$this->db->where('email_address', $args['email_address']);
			$this->db->where('password', $args['password']);
		}

		if (isset($args['email_address']) && $args['email_address']) {
			$this->db->where('email_address', $args['email_address']);
		}

		if (isset($args['display_name']) && $args['display_name']) {
			$this->db->where('display_name', $args['display_name']);
		}
		
		$this->db->order_by('user_level, last_name, first_name');

	}
	
	public function save($user_id=NULL,$activation_code=NULL) {

		// User settings
		$user_salt = $this->salt();
		$_POST['salt'] = $user_salt;
		$_POST['password'] 	= ($_POST['password']==NULL ) ? NULL : sha1($_POST['password'] . $user_salt);
		
		if($_POST['active']=='on')
            $_POST['active']=$this->active;
         else
            $_POST['active']=0;
            
		if ($user_id != NULL) {
			// update informations on a user
			if($_POST['password']==NULL ){
				unset( $_POST['password'] );
				unset( $_POST['salt'] );
			//	$_POST['active'] = $this->active;
			}
			$this->db->where('user_id', $user_id);
			$flag=$this->db->update($this->db->dbprefix($this->table_users), $_POST);
		}
		else {
			// create a new user
			$_POST['activation_code'] = $activation_code;
			$this->session->set_userdata('passage_save', $this->session->userdata('passage_save')+1);
			$flag=$this->db->insert($this->db->dbprefix($this->table_users), $_POST);
		}
		
		return $flag;
	}

	public function delete($user_id=NULL) {

		if ($user_id != NULL) {
			$this->db->where('user_id', $user_id);
			return $this->db->delete($this->db->dbprefix($this->table_users));
		}
		return FALSE;
	}

	public function auth ($email_address, $password) {
		
		$db_array = array(
		'email_address'	=>	$email_address,
		'success'		=>	0,
		'date'			=>	time());
		
		if ($this->_email_check($email_address)) {
			
			$user = $this->get_user_by_email($email_address);

			$this->db->where('email_address', $email_address);

			$this->db->where('password', sha1($password . $user->salt));

			$query = $this->db->get($this->db->dbprefix($this->table_users));

			if ($query->num_rows() && $query->row()->active == 1) {
				$db_array['success'] = 1;
				$this->db->where('user_id', $query->row()->user_id);
				$this->db->update($this->db->dbprefix($this->table_users), array('lastlogon'=>date('Y-m-d H:i:s')));											
				$return = $query->row();
			}
			else {
				$db_array['success'] = 0;
				$return = FALSE;
			}
		}
		else {
			 return FALSE;
		}
				
		$this->db->insert($this->db->dbprefix($this->table_users_log), $db_array);
		
		return $return;
		
	}

	
	public function activate ($user) {
			
			if(is_numeric($user))
				$this->db->where('user_id', $user);
			else
				$this->db->where('email_address', $user);
			
			$data=array('active'=>'1');
			$this->db->update($this->db->dbprefix($this->table_users),$data);
	}
	
	
	public function verifactivation ($email_address,$activationcode) {
		$db_array = array(
		'email_address'	=>	$email_address,
		'date'			=>	time());
		
		if ($this->_email_check($email_address)) {
			$user = $this->get_user_by_email($email_address);
			$this->db->where('email_address', $email_address);
			$this->db->where('activation_code', $activationcode);
			$query = $this->db->get($this->db->dbprefix($this->table_users));
			if ($query->num_rows()) {
				$db_array['success'] = 1;
				$this->db->where('user_id', $query->row()->user_id);
				$this->db->update($this->db->dbprefix($this->table_users), array('lastlogon'=>date('Y-m-d H:i:s')));										
				$return = $query->row();
			}
			else {
				$db_array['success'] = 0;
				$return = FALSE;
			}
		}
		else {
			 return FALSE;
		}
		
		return $return;
		}
		
	public function changepasswd ($email_address,$mailsend) {
		
		$db_array = array(
		'email_address'	=>	$email_address,
		'date'			=>	time());
		
		
		if ($this->_email_check($email_address)) {

			//update database
			if($mailsend){// le mail a bien été envoyé
				$user = $this->get_user_by_email($email_address);
				$data=array('password'=>sha1($newpasswd . $user->salt));
				$this->db->where('email_address', $email_address);
				$this->db->update($this->db->dbprefix($this->table_users),$data);
				
				echo"Password sent by mail".$mailsend;
				die();
				
			}
			else{
				echo "impossible to sent on this email".$mailsend;
				echo $this->email->print_debugger();
				die();
				
				}
				$return=TRUE;
		}
		else {
			$return = FALSE;
			echo "email not found in user database".$mailsend;
			die();
		}
		
		return $return;
		
	}

	public function logout() {

		// destroy all sessions
		return $this->session->sess_destroy();

	}
	
	public function loggedIn(){

		$user_id = $this->session->userdata('user_id');
		if($user_id == NULL || $user_id == 0)
			return FALSE;

		return $this->session->userdata('user_level');
	}

	public function check_subscriber($email_address='') {

		// used from the admin controller to check and see if an subscriber exists.  if not one can be created.
		$this->db->where('email_address', $email_address);
		$query = $this->db->get($this->db->dbprefix($this->table_users));

		if ($query->num_rows()===1) {
			return TRUE;
		}
		else {
			return FALSE;
		}
	}
			
	public function check_admin() {

		$this->super_admin_level = $this->Usergroups_model->get_group(array('group_name'=>'Superadmin'))->row()->user_level;// manage a rights		
		$this->admin_level = $this->Usergroups_model->get_group(array('group_name'=>'Administrator'))->row()->user_level;

		// used from the admin controller to check and see if an admin exists.  if not one can be created.
		$this->db->where('user_id', $this->session->userdata('user_id'));
		$query = $this->db->get($this->db->dbprefix($this->table_users));

		if ($query->num_rows()===1 && ($query->row()->user_level==$this->admin_level || $query->row()->user_level==$this->super_admin_level)) {
			return TRUE;
		}
		else {
			return FALSE;
		}
	}

	public function check_Superadmin() {

		$this->super_admin_level = $this->Usergroups_model->get_group(array('group_name'=>'Superadmin'))->row()->user_level;// manage a rights		
		// used from the super admin controller to check and see if an admin exists.  if not one can be created.
		$this->db->where('user_id', $this->session->userdata('user_id'));
		$query = $this->db->get($this->db->dbprefix($this->table_users));
		if ($query->num_rows()===1 && $query->row()->user_level==$this->super_admin_level) {
			return TRUE;
		}
		else {
			return FALSE;
		}
	}
		
	public function get_by_group() {

		$this->load->model('usergroups_model');
		
		$user_groups = array();
		
		$user_levels = $this->usergroups_model->get_groups ();

		foreach ($user_levels as $user_level) {
			
			$this->db->where('user_level', $user_level);
			$this->db->order_by('last_name, first_name');
			$query = $this->db->get($this->db->dbprefix($this->table_users));
			
			$user_groups[$user_level]['user_level'] = $user_level;
			$user_groups[$user_level]['users'] = $query->result();
						
		}
		
		return $user_groups;

	}

	public function _email_check($email_address) {
		
		// used from the email_address controller to check and see if an email exists.  if not one can be created.
		$this->db->where('email_address', $email_address);
		$query = $this->db->get($this->db->dbprefix($this->table_users));

		return	($query->num_rows()) ? 	TRUE : FALSE;
	}

	public function get_user_by_email($email_address) {

		$this->db->where('email_address', $email_address);
		$query = $this->db->get($this->db->dbprefix($this->table_users));

		if ($query->result()) {

			return $query->row();
		}

		else {

			return FALSE;

		}
	}

	public function get_email_by_id($user_id) {
		$user= $this->get_user_by_id($user_id);
		return $user->email_address;
	}
	
	public function get_user_by_id($user_id) {

		$this->db->where('user_id', $user_id);
		$query = $this->db->get($this->db->dbprefix($this->table_users));

		if ($query->result()) {

			return $query->row();
		}

		else {

			return FALSE;

		}
	}

	/**
	 * Generates a random salt value.
	 *
	 * @return void
	 * @author Mathew
	 **/
	public function salt()
	{
		return substr(md5(uniqid(rand(), true)), 0, $this->salt_length);
	}


   /*
   * author: tchekjunior
   * date:  11oct sept 2012
   * comment:
   * recuperer l'id du module grace au nom / false
   */
   protected function get_id_module( $name_module ){

      $row = $this->db->select()
              ->from( $this->db->dbprefix($this->table_modules))
              ->where('name',$name_module )
              ->get()->row();

      return $row->mid;
   }


   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * comment:
   * recuperer l'id du groupe / false
   */
  protected  function get_id_group(){

      $row = $this->db->select()
              ->from( $this->db->dbprefix($this->table_users))
              ->where('user_id',$this->session->userdata('user_id') )
              ->get()->row();

      return $row->u_group_id;
   }
   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * comment:
   * changer le groupe d'un utlisateur
   *
   public function changeGroup($id_new_group){

     return $this->db->where('user_id',$this->session->userdata('user_id') )
                     ->update($this->db->dbprefix($this->table_users),
                               array( Groups_model::U_GRP_ID => $id_new_group)
                             );

   }
    *
    */

   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * comment:
   * verifier autorisation pour acceder et visualiser le moule
    * $module_name: id(int) ou nom du module(string)
    * return: boolean
   */
   public function have_view_access($name_module){
      
      return $this->Usergroups_model->have_view_access( $this->get_id_group(), $this->get_id_module($name_module));
   }
   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * comment:
   * verifier autorisation pour creer ou modifier une donne
    * $module_name: id(int) ou nom du module(string)
    * return: boolean
   */
   public function  have_edit_access($name_module){

      return $this->Usergroups_model->have_edit_access( $this->get_id_group(), $this->get_id_module($name_module));

   }
   /*
   * author: tchekjunior
   * date: lundi, 24 sept 2012
   * comment:
   * verifier autorisation de suppression dans un module
    * $module_name: id(int) ou nom du module(string)
    * return: boolean
   */
   public function have_delete_access($name_module){

      return $this->Usergroups_model->have_delete_access( $this->get_id_group(), $this->get_id_module($name_module));
   }

}

/* End of file users_model.php */
/* Location: ./application/models/users_model.php */
