<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Backoffice
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/03  17:10   gabriel gbobard@gmail.com
 */

class Administrator extends MY_Controller {


	public $test_sessions;	// for debugg
	public  $code_lang;
		
    public $table  = 'posts';
    public $table1 = 'pages';
    
	public function __construct(){
		
		parent::__construct();

		$this->LoadLangModule('backoffice', $this->session->userdata('language'));		
		$this->load->model('Usergroups_model');

	}
		
	public function index()	{

		if (!$this->is_subscriber) { // inscrit on this plateforme
			redirect('backoffice/administrator/doLogin');
		} 
		
		$data = array(
			'sub_nav'=> 'dashboard',
			'view' => 'dashboard'
		);
		
		$this->display('dashboard', 'backoffice', 'left', $data);
	}

	public function dashboard()	{

		redirect('backoffice/administrator');
	}

	public function check_credentials() {

		if ($this->session->userdata('user_level') <> 2) {
			redirect('backoffice/administrator/doLogin');
		}

	}


	public function doLogin() {

		//$this->_first_login();

		$this->form_validation->set_rules('email_address', $this->lang->line('email_address'), 'required|valid_email');
		$this->form_validation->set_rules('password', $this->lang->line('password'), 'required' );

		if (!$this->form_validation->run()) {

			if ($this->session->flashdata('login_error')) {
				$this->validation->error_string = $this->lang->line('login_error');
			}

			elseif ($this->session->flashdata('login_not_admin')) {
				$this->form_validation->error_string = $this->lang->line('login_not_admin');
			}

			$data = array(
				'pagetitle'	=>	'CandleCMS ' . $this->lang->line('administration_panel'),
				'sub_nav'=> 'administrator',
				'view' => 'login'
			);
			
			$this->display('login', 'backoffice', 'none', $data);

		}

		else {

			$user = $this->Users_model->auth($this->input->post('email_address'), $this->input->post('password'));

			if ($user->email_address) {

				if ($this->Users_model->check_subscriber($user->email_address)) {

					$this->set_session($user);

					$this->session->set_userdata('is_superadmin', $this->Users_model->check_Superadmin($user->email_address));
					$this->session->set_userdata('is_admin', $this->Users_model->check_admin($user->email_address));
					$this->session->set_userdata('is_subscriber', $this->Users_model->check_subscriber($user->email_address));
								
					$this->is_superadmin = $this->session->userdata('is_superadmin');
					$this->is_admin = $this->session->userdata('is_admin');
					$this->is_subscriber = $this->session->userdata('is_subscriber');

					redirect('backoffice/administrator');

				}
 
				else {

					//$this->session->set_flashdata('login_not_admin', 'TRUE');
               $this->_setMessage('Sorry but you do not have access to the Administration Panel.','error');
					redirect('backoffice/administrator/doLogin');

				}

			}

			else {

				//$this->session->set_flashdata('login_error', 'TRUE');
            
            $this->_setMessage('Your username and / or password is incorrect.','error');
				redirect('backoffice/administrator/doLogin');

			}

		}

	}

	function doLogout(){
		$this->Users_model->logout();
		redirect('backoffice/administrator');
	}

	public function _first_login() {
		if (!$this->Users_model->check_admin()) {
			redirect('backoffice/administrator/first_login');
		}
	}


	public function first_login() {

		if ($toto==1) {

			$this->form_validation->set_rules('email_address', 'Email_address', 'required|valid_email');
			$this->form_validation->set_rules('password', 'Password', 'required');
			$this->form_validation->set_rules('password_conf', 'Password Confirmation', 'required|matches[password]');
			$this->form_validation->set_rules('display_name', 'Display Name', 'required');

			if (!$this->form_validation->run()) {

				$data = array(
					'pagetitle'	=>	'CandleCMS ' . $this->lang->line('administration_panel'),
					'sub_nav'=> 'administrator',
					'view' => 'first_login'
				);
			
				$this->display('login', 'backoffice', 'none', $data);
			}

			else {

				$this->Users_model->email_address = $this->input->post('email_address');
				$this->Users_model->password = $this->input->post('password');
				$this->Users_model->display_name = $this->input->post('display_name');
				$this->Users_model->user_level = $this->admin_level; // create one Administrator only
				$_POST['user_level'] = $this->super_admin_level;			
				unset( $_POST['password_conf'] );
				unset( $_POST['btnSubmit'] );
				
				$this->Users_model->save();

				redirect('backoffice/administrator');

			}

		}

		else {

			redirect('backoffice/administrator');

		}

	}
	
	public function passwdsend() {

		$this->form_validation->set_rules('email_address', $this->lang->line('email_address'), 'required|valid_email');

		if (!$this->form_validation->run()) {

			if ($this->session->flashdata('login_error')) {
				$this->validation->error_string = $this->lang->line('login_error');
			}

			elseif ($this->session->flashdata('login_not_admin')) {
				$this->form_validation->error_string = $this->lang->line('login_not_admin');
			}

			$data = array(
				'pagetitle'	=>	'CI-custom2 ' . $this->lang->line('administration_panel'),
				'sub_nav'=> 'administrator',
				'view' => 'passwdrescue'
			);
				
			$this->display('login', 'backoffice', 'none', $data);

		}

		else {
			
			$email_address=$this->input->post('email_address');
			
			$config['protocol'] = 'smtp';
			$config['smtp_host'] = 'localhost';
			$config['mailpath'] = '/usr/sbin/sendmail';
			$config['charset'] = 'iso-8859-1';
			$config['wordwrap'] = TRUE;
			//generate a new password
			$newpasswd=random_string('alnum',8);

				$message=' Your password account is reinit =>  '.$newpasswd.' is a new password.';
				
				if(mail($email_address,'password forgotten',$message)){
					$mailsend=TRUE;
				}
			
				else{
					$this->load->library('email');
					$this->email->from($this->config->item('newsletter_email'));
					$this->email->to($email_address);
					$this->email->subject('CandleCMS password forgotten');		
					$mailsend=$this->email->send();
				}
				
			$pass = $this->Users_model->changepasswd($this->input->post('email_address'),$mailsend);

			if ($pass) {

					redirect('backoffice/administrator/doLogin');
			}

			else {

				$this->session->set_flashdata('login_error', 'TRUE');
				redirect('backoffice/administrator/passwdsend');

			}

		}

	}
	
	public function set_session($user) {
		
		$session_data = array(
		'logged_in'		=>	TRUE,
		'user_id'		=>	$user->user_id,
		'group_name'	=>	$this->Usergroups_model->get_group (array('user_level'=> $user->user_level ))->row()->group_name,
		'display_name'	=>	$user->display_name,
		'email_address'	=>	$user->email_address,
		'user_level'	=>	$user->user_level,
		'u_group_id'	=>	$user->u_group_id
		);
		
		$this->session->set_userdata($session_data);
		// load access Right for this user connected
		$this->useraccessright=$this->UserAccessRight();
		$this->session->set_userdata('user_access_right', $this->useraccessright );
		$this->test_sessions = 1;
	}

	// switch lang	
	public function languages ($mylang='english', $view='dashboard')
	{
		$this->code_lang = $this->setCurrentLang($mylang);	
		redirect('backoffice/' . $view);
	}
	
	public function backupMysql ()
	{	
			// Load the DB utility class
		$this->load->dbutil();

		// Backup your entire database and assign it to a variable
		$backup =& $this->dbutil->backup();

		// Load the file helper and write the file to your server
		$this->load->helper('file');
		$mybackupFile = 'candlecms_mybackup'.date('d-m-Y-H-i-s', time()).'.gz';
		write_file(getcwd().'/assets/uploads/'.$mybackupFile, $backup);

		// Load the download helper and send the file to your desktop
		$this->load->helper('download');
		force_download($mybackupFile, $backup); 
		
		redirect('backoffice/administrator');
	}	
}
/* End of file administrator.php */
/* Location: ./application/controllers/administrator.php */
