<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Backoffice
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/03  17:10   gabriel gbobard@gmail.com
 */


class Analytics extends MY_Controller {
	
	function __construct(){
		parent::__construct();
		
		if(!$this->Users_model->loggedIn() || $this->Users_model->loggedIn() < 9) 
			redirect('backoffice/administrator');
					
		$this->load->model('Analytics_model');
		$this->load->helper( 'string' );				
	}
	
	function index($message=null){
		//$this->output->enable_profiler();
		$this->load->helper('chart');

		$data = array (
			'visits' => $this->Analytics_model->getVisitorsCount(),
			'unique_visits' => $this->Analytics_model->getUniqueVisitorsCount(),
			'pages' => $this->Analytics_model->getPagesCount(),
			'content_overview' => $this->Analytics_model->getContentOverview(),
			'content_count' => $this->Analytics_model->getContentCount(),
			'referrers' => $this->Analytics_model->getReferrers(),
			'sub_nav'	 => 'analytics',
			'view' => 'analytics'
		);
		
		$this->display('analytics', 'backoffice', 'none', $data);
	}
	
	function visitors(){
		$data = array(
			'visitors'	 => $this->Analytics_model->getVisitors(),
			'sub_nav'	 => 'analytics',
			'view'		 => 'analytics'
		);
		
		//$this->load->view('admin/analytics/chart_visitors', $data);
		$this->display('analytics', 'backoffice', 'none', $data);
	}
	
	function visitorsSmall(){
		$data = array(
			'visitors' => $this->Analytics_model->getVisitors(),
			'sub_nav'	 => 'analytics',
			'view'		 => 'analytics'
		);
		
		$this->load->view('admin/analytics/chart_visitors_small', $data);
	}
	
	function referrers(){
		$data = array(
			'referrer_overview' => $this->Analytics_model->getReferrerOverview(),
			'sub_nav'	 => 'analytics',
			'view'		 => 'analytics'
		);
		
		$this->load->view('admin/analytics/chart_traffic_sources_overview', $data);
	}
	
	
}
