<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Events
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 * @license         GNU General Public License version 3.0 (GPLv3)
 *
 * Events model.
 * update 2011/06/04  17:10   gabriel  gbobard@gmail.com
 */

class Events extends MY_Controller {

	function __construct(){
		parent::__construct();

		//load helpers
		$this->load->helper('html');
		//load models
		$this->load->model(array('Events_model','Categories_model'));
		//set module
		$this->Categories_model->setModule('events');
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language'));
		// test if access right Can View
		$this->canView($this->Categories_model->module);		
	}
	
	function index($year= NULL, $month= NULL){ 
		
		if($year == NULL)
			$year = date('Y');
		if($month == NULL)
			$month = date('m');
		
		$result = $this->Events_model->getEventsInMonth($month, $year);
		
		$data = array();		
		foreach($result->result_array() as $row){
			$data[$row['start_day']][] = $row;
		}
		
		$prefs['show_next_prev']  = TRUE;
		$prefs['next_prev_url']   = site_url('backoffice/events/index');
		$prefs['day_type'] = 'long';

		
             
         $prefs['template'] = '

		   {table_open}<table border="0" cellpadding="0" cellspacing="1" width="100%" class="calendar" bgcolor="#a7aab3">{/table_open}
		
		   {heading_row_start}<tr>{/heading_row_start}
		
		   {heading_previous_cell}<th><a href="{previous_url}">&#139;</a></th>{/heading_previous_cell}
		   {heading_title_cell}<th colspan="{colspan}">{heading}</th>{/heading_title_cell}
		   {heading_next_cell}<th><a href="{next_url}">&rsaquo;</a></th>{/heading_next_cell}
		
		   {heading_row_end}</tr>{/heading_row_end}
		
		   {week_row_start}<tr>{/week_row_start}
		   {week_day_cell}<td style="height: 17px; font-weight: bold; text-align: center;">{week_day}</td>{/week_day_cell}
		   {week_row_end}</tr>{/week_row_end}
		
		   {cal_row_start}<tr>{/cal_row_start}
		   {cal_cell_start}<td width="14%">{/cal_cell_start}
		
		   {cal_cell_content}{day}{content}<a href="{link}">{title}</a>{/day}{/cal_cell_content}
		   {cal_cell_content_today}<div class="highlight"><a href="{content}">{day}</a></div>{/cal_cell_content_today}
		
		   {cal_cell_no_content}{day}{/cal_cell_no_content}
		   {cal_cell_no_content_today}<div class="highlight">{day}</div>{/cal_cell_no_content_today}
		
		   {cal_cell_blank}&nbsp;{/cal_cell_blank}
		
		   {cal_cell_end}</td>{/cal_cell_end}
		   {cal_row_end}</tr>{/cal_row_end}
		
		   {table_close}</table>{/table_close}
		';
		$this->load->library('calendar', $prefs);
	
		$data = array(
			'nav'=>(!isset($nav)) ? '' : $nav, 
			'calendar'=>$this->calendar->generate($this->uri->segment(4), $this->uri->segment(5),$data),
			'sub_nav'=>'events',
			'view'=>'events_home'
		);

		$this->display('events', 'backoffice', 'none', $data);
	}
	
	/**
	 * Index function. Displays the calendar.
	 *
	 * @param int $month
	 * @param int $year
	 * @param string $message
	 */
	function indexOld($month=null, $year=null, $message=null){
		$data = array();
		
		//_POST data exists, from ajax request, hide header
		if(isset($_POST['m']) && isset($_POST['y'])){
			$data['calendar_content'] = $this->Events_model->showCalendar($_POST['m'], $_POST['y']);
		}
		//no _POST data, load headers and nav
		else{
			$month = ($month == null) ? date('m') : $month;
			$year = ($year == null) ? date('Y') : $year;
			$data['calendar_content'] = $this->Events_model->showCalendar($month, $year);
			$load_footer = true;

			$data['view'] = 'events_navig';			
			$this->display('events', 'backoffice', 'none', $data);					
		}
		
		if(isset($message) && $message != NULL)
			$data['message'] = $message;

		$data['view'] = 'events_home';			
		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function event($id){
		$data = array(
			'events' => $this->Events_model->getEvents("id=$id"),
			'sub_nav' => 'events',					
			'view'=> 'events_event'			
		);

		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function add($year=NULL,$month=NULL,$day=NULL){
		
	//var_dump($year);var_dump($month);var_dump($day);die();
		$data['categories'] = $this->Categories_model->getTreeDD(0);
		
		$data['sub_nav'] = 'events';
		if(isset($year) && isset($month) && isset($day)){
			$date	=$day.'-'.$month.'-'.$year;
			$date= date_format(date_create_from_format('j-n-Y',$date), 'n/d/Y');	
		}
		else $date=  date('n/j/Y');
		$data['view'] = 'events_add';
		$data['date']=$date;		
		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function edit($id){

		if(isset($id) && $id != NULL)
			$data['row'] = $this->Events_model->getEvents("id=$id")->first_row('array');

		if(!isset($data['row']['cat_id']) && $data['row']['cat_id'] = NULL)
			$data['row']['cat_id'] = 0;

		$data['categories'] = $this->Categories_model->getTreeDD($data['row']['cat_id']);
		
		$data['sub_nav'] = 'events';			
		$data['view'] = 'events_add';	
				
		$this->display('events', 'backoffice', 'none', $data);	
	}
	
	function save($id=NULL){
		$result = $this->Events_model->saveEvent($id);
		
		redirect("backoffice/events/index/$result[year]/$result[month]");
		//$this->index($result['month'], $result['year'], $result['message']);
	}
	
	function delete($id){
		$result = $this->Events_model->deleteEvent($id);
		redirect("backoffice/events/index/$result[year]/$result[month]");
		//$this->index($result['month'], $result['year'], $result['message']);
	}
	
	function quickAdd($year, $month, $day){
		$data = array (
			'date' => $year . '/' . $month .'/'. $day,
			'categories' => $this->Categories_model->getTreeDD()
		);
		
		$this->load->view('admin/events/event_add_quick', $data);
	}
	
	function agenda($offset=0){
      
		$this->load->library('pagination');
		$config['base_url'] = site_url('backoffice/events/agenda/');
		$config['total_rows'] = $this->Events_model->getEvents(array('count'=>TRUE,'upcoming_only'=>TRUE));
		$config['per_page'] = 10;
		$config['uri_segment'] = 4;
		$config['num_links'] = 4;
		$this->pagination->initialize($config);

		$data = array(
			'events' => $this->Events_model->getEvents("offset=$offset&limit=$config[per_page]&upcoming_only=1"),
			'sub_nav' => 'events',
			'view' => 'events_agenda',
			'page_links'    =>  $this->pagination->create_links(),
			'categories' => $this->Categories_model->getCategories()->result_array(),
			
		);

	$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function locationSearch(){
		$data = array(
			'locations'=>$this->Events_model->getLocations($_POST['location']),
			'sub_nav' => 'events',
			'view' => 'locations_autocomplete'				
				);
		
		$this->load->view('admin/events/locations_autocomplete', $data);
	}
	
	function locations($loc_id='%'){
		$data = array(
			'locations'=>$this->Events_model->getLocations($loc_id),
			'sub_nav' => 'events',
			'view' =>  (is_numeric($loc_id)) ? 'events_locations_edit' : 'events_locations'
		);
		
		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function saveLocation($loc_id){
		$this->Events_model->saveLocation($loc_id);
		
		//$this->locations();
		redirect('backoffice/events/locations');
	}
	
	function deleteLocation($loc_id){
		$this->Events_model->deleteLocation($loc_id);
		
		//$this->locations();
		redirect('backoffice/events/locations');
	}
	
	
	function timeSearch(){
		$search_time = ($_POST['start_time'] == null) ? $_POST['end_time'] : $_POST['start_time'];
		$data = array(
			'times'=>$this->Events_model->getTimes($search_time),
			'sub_nav' => 'events',
			'view' => (is_numeric($loc_id)) ? 'events_locations_edit' : 'events_locations'
		);
		
		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function ical($type='public.ics'){
		if($type == 'all.ics')
			$data['events'] = $this->Events_model->getEvents();
		elseif($type == 'events.ics')
			$data['events'] = $this->Events_model->getEvents('cat_id IN (12, 13, 15)');
		elseif($type == 'conflicts.ics')
			$data['events'] = $this->Events_model->getEvents('cat_id = 14');
		elseif($type == 'public.ics')
			$data['events'] = $this->Events_model->getEvents('cat_id = 12');

		
			$data['sub_nav'] = 'events';
			$data['view'] =  (is_numeric($loc_id)) ? 'events_locations_edit' : 'events_locations';

		header("Content-Type: application/ical");

		
		$this->display('events', 'backoffice', 'none', $data);		
	}
	
	function rss($type='news'){
			redirect('backoffice/events');		
				
	}
	
	function feeds(){
			redirect('backoffice/events');		
				
	}
	public function category($cat_id=null, $offset=0){
		$cat_id = ($cat_id == null) ? $_POST['cat_id'] : $cat_id;
		
		if($cat_id == 'ALL'){
			$this->session->unset_userdata('events_category');
			redirect('backoffice/events/agenda');
		}
		else {
			$this->session->set_userdata('events_category', $cat_id);
			
			//setup pagination
			$this->load->library('pagination');
			$config['base_url'] = site_url('backoffice/events/category/'.$cat_id);
			$config['total_rows'] = $this->Events_model->get(array('category_in'=>$cat_id,'count'=>TRUE));
			$config['per_page'] = 10;
			$config['uri_segment'] = 5;
			$config['num_links'] = 4;
			$this->pagination->initialize($config);
			
			$data = array(
				'events' => $this->Events_model->getEvents(array('category_in'=>$cat_id,'limit'=>$config['per_page'],'offset'=>$offset)),
				'page_links' => $this->pagination->create_links(),
				'crumbs' => $this->Categories_model->breadCrumbs($cat_id),
            'sub_nav'=>'events',
				'view' => 'events_agenda'
			);
			
			$this->display('events', 'backoffice', 'none', $data);
		}
	}
}

/* End of file events.php */
/* Location: ./application/backoffice/controllers/events.php */
