<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Templates_model
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/15  17:10   Melanie LONTSI KENLAK mel.lansi@gmail.com
 */
class languages extends MY_Controller {

	private $id;
	private $code;
	private $name;

	public function __construct(){
 		parent::__construct();
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language')); 		
		// test if access right Can View
		$this->canView('languages');
		//load models lang
		$this->load->model('Languages_model');
		
    }

	public function index($value=NULL) {


		$this->language = $this->Languages_model->get();

		$data['mylanguages'] = $this->Languages_model->getAllLang();
		$data['pagetitle'] = 'CandleCMS ' . $this->lang->line('administration_panel') . ' - ' . $this->lang->line('language_manage');
		$data['sub_nav'] ='languages';
		$data['view'] = 'languages_home';
             
		$this->display('languages', 'backoffice', 'none', $data);
	}
	
	/**
	 * Edit a lang
	 *
	 * @param int $id
	 */
	function edit($id=0){
		
		$this->canEdit('languages');
				
		$data = array(
			'language' => $this->Languages_model->getLang($id)->first_row('array'),
			'sub_nav' => 'languages',
			'view' => ($id==0) ? 'languages_add' : 'languages_edit'
		);
		
		$this->display('languages','backoffice','none',$data);
	}
	
	/**
	 * Add a new lang
	 *
	 */
	function add(){
		$this->edit();
	}
	
	/**
	 * Save lang, upload photo if necessary
	 *
	 * @param int $id
	 */
	function save($id=null){

		if(isset($_POST['name']) && empty($_POST['name'])){
			$this->_setMessage('Your field [ name ] is NULL or empty !!!', 'error');			
			redirect('backoffice/languages/edit/'.$id);
		}
		
		if(empty($_POST['code'])){
			$this->_setMessage('Your field [ code ] lang as empty.', 'error');			
			redirect('backoffice/languages/edit/'.$id);
		}

		if(isset($_FILES ['lang_image'] ['name']) && $_FILES ['lang_image'] ['name'] !=NULL){

			//load photos model
			$this->load->model('Photos_model'); 

			//get default image sizes
			$opts['large_size'] = array ('w' => 45,'h' => 30);
			$opts['upload_path'] = $this->Users_model->getOption('file_upload_path').'languages/';
			$opts['allowed_types'] = $this->Photos_model->getOption('image_allowed_types');

			//upload the image
			$image_data = $this->_uploadFile( $opts );

			//if successuflly uploaded, add image field to _POST array
			if($image_data[0]['raw_name'] != NULL){
				$_POST['image'] = $image_data[0]['orig_name'];
				$_POST['filename'] = $image_data[0]['raw_name'];
				$_POST['filetype'] = strtolower(substr($image_data[0]['file_ext'], 1));
			}
		}
		
		if($this->Languages_model->save($id))
			$this->_setMessage('Your language has been saved.', 'success');
		else
			$this->_setMessage('Oops, there was a problem saving your language.', 'error');

		redirect('backoffice/languages');
	}
	
	/**
	 * Delete lang
	 *
	 * @param int $id
	 */
	function delete($id){

		$this->canDelete('languages');

		if( $this->languages_model->getAllLang()->num_rows() === 1){
			$this->_setMessage('Oops, there was a problem deleted your language, record number is one only ', 'error');
			redirect('backoffice/languages');
		}

		if($this->Languages_model->delete($id)){
			$row = $this->Languages_model->getLang($id)->first_row();

			$upload_path = $this->Languages_model->getOption('file_upload_path').'languages/';
			$this->_deleteFile($upload_path, $row->filename, $row->filetype);
			
			$this->_setMessage('Your language has been deleted.', 'success');
		} else {
			$this->_setMessage('Oops, there was a problem deleted your language.', 'error');
		}
		redirect('backoffice/languages');
	}
	
	public function makedefault() {

        $this->Languages_model->name =$_POST['name'];
        //setting the template to be default
		$this->Languages_model->makedefault();
		
		redirect('backoffice/languages');
	}
}
