<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Logins extends MY_Controller {


	public function __construct(){
		parent::__construct();
		
		if(!$this->Users_model->loggedIn() || $this->Users_model->loggedIn() < 9) 
			redirect('backoffice/administrator');

		$this->load->model('logins_model');

	}

	function index($offset=0) {
		
		$this->load->library('pagination');

			// args array 'count'=> 1  counter row  'count'=> NULL  return FALSE if rows = 0
		$config['base_url']   = site_url('backoffice/logins/page');
		$config['total_rows'] = $this->logins_model->getLogins(array('count'=> 1));
		$config['per_page']		= 20;
		$config['uri_segment']	= 4;
		$config['num_links']	= 4;
		
		$this->pagination->initialize($config);
		
		$data = array(
			'logins'	=> $this->logins_model->getLogins(array('limit'=>$config['per_page'],'offset'=>$offset)),
			'page_links'=> $this->pagination->create_links(),
			'sub_nav'	=> 'users',
			'view'	 	=> 'users_logins'
		);

		$this->display('users', 'backoffice', 'none', $data);
	}
	
	/**
	 * Used for pagination. Calls the index() method.
	 *
	 * @param int $offset
	 */
	public function page($offset=0){
		$this->index($offset);
	}

}
/* End of file logins.php */
/* Location: ./application/modules/backoffice/logins.php */
