<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Backoffice
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 * @license     GNU General Public License version 3.0 (GPLv3)
 *
 * Newsletter controller.
 * update 2011/05/15  17:10   Mélanie mel.lontsi@gmail.com  and Gabriel
 */
class Newsletter extends MY_Controller{
	
	function __construct(){
		parent::__construct();

		$this->load->model('Newsletter_model');
		$this->load->model('Categories_model');
		$this->Categories_model->setModule('newsletter');
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language'));
		// test if access right Can View
		$this->canView($this->Categories_model->module);

		$site_name = substr(base_url(),7,-1);
		$this->from_addr = $site_name . ' <list-admin@'.$site_name.'>';

	}
	
	public function index(){
            $this->compose();
	}
	
	public function compose(){
		
		$this->canEdit($this->Categories_model->module);
				
		$data = array(
			'total'=>$this->Newsletter_model->getSubscriberCount(),
			'categories'=> $this->Categories_model->getTreeDD(),
            'sub_nav'	=> 'newsletter',
			'view'		=>'newltr_compose'
		);
		
        $this->display('newsletter', 'backoffice', 'none', $data);
	}
	
	public function delete($id){

		$this->canDelete($this->Categories_model->module);
		$this->Newsletter_model->delete($id);
	}
	
	/**
	 * Add an email address to the database.
	 * Ajax calls this!
	 *
	 */
        
	public function add($id=null){

      if(isset($id) && ($id!=null) && $_POST){
         //UPDATE
       
           
         $this->Newsletter_model->updateSubscribers($id,$_POST);
         $this->_setMessage("Email Address Updated successfully.", 'success');
     
         redirect('backoffice/newsletter/subscribers');
      }
      else{
         //INSERT

            if($this->Newsletter_model->insert($this->input->post('address'),$this->input->post('category'))){
               echo "<img src='".base_url()."assets/themes/backoffice/images/tick.png' style='vertical-align: middle' /> ".
				" Added successfully.";
           
            }
         else
            echo $_POST['address']." <img src='".base_url()."assets/themes/backoffice/images/cross.png' style='vertical-align: middle' /> ".
               " Address invalid or already exists.";
               
         }
	}
	
	public function addSubscriber($id=null){


      if(isset($id)){
				$data['row'] = $this->Newsletter_model->get(array('id'=>$id))->first_row('array');
			}
		$data['categories'] = $this->Categories_model->getTreeDD();

		//$data['view']='newltr_add_subscriber';
      $data['view']		  =  (isset($id)) ? 'newltr_edit_subscriber' : 'newltr_add_subscriber';
		$data['sub_nav']='newsletter';
		
		$this->display('newsletter', 'backoffice', 'none', $data);
      
	}
   
	
	public function send(){
		
		if($this->Newsletter_model->getSubscriberCount() > 10){
			//send via mass mailer
			$this->_sendMass();
		} else {
			//send via mail() function
			$this->_sendRegular();
		}
	}
	
	private function _sendRegular(){

        $data = array();

		$data['subject'] = $_POST['subject'];

		$data['message'] = $this->config->item('app_name_short')."\r\n MESSAGE: " .  nl2br($_POST['message']) . 
			"<br/><br/><br/><span style='font-size: 10px'>" . $_POST['footer'] . "</span>";
			
		// To send HTML mail, the Content-type header must be set
                $headers  = 'MIME-Version: 1.0' . "r\n";
                $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
                $headers .= 'From : '. $this->from_addr ."\r\n";
                $headers .= "\r\n";
		$data['headers'] = $headers;
        
        $data['function_email'] = $this->config->item('function_email');

		if ($this->Newsletter_model->send($data)){
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/tick.png'> Your message has been queued and will be sent shortly!";
			$this->_setMessage($message, 'success');
		}
		else{
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/cross.png'> Your message has not been sent ( error )!!!";		
			$this->_setMessage($message, 'error');
		}
		redirect('backoffice/newsletter');
	}
	
	private function _sendMass(){
    
		$data = array();
		$data['subject'] = $_POST['subject'];
		$data['message'] = nl2br($_POST['message']) . "<br/><br/><span style='font-size: 10px'>" . $_POST['footer'] . "</span>";
		
		if(strlen($data['message']) > 19000)
			die("Your message is too long. Please click the back button on your browser to edit and 
				shorten your message");
		
			// To send HTML mail, the Content-type header must be set
                $headers  = 'MIME-Version: 1.0' . "\r\n";
                $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From: '.$this->from_addr ."\r\n";
		$data['headers'] = $headers;
        
        $data['function_email'] = $this->config->item('function_email');

		if ($this->Newsletter_model->queueMass($data)){
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/tick.png'> Your e-mails have been queued and will be delivered shortly!.";
			$this->_setMessage($message, 'success');
		}
		else{
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/cross.png'> Your e-mails has not been sent !!!";		
			$this->_setMessage($message, 'error');
		}
		redirect('backoffice/newsletter');
	}
	
	public function sendTest()	{
		//print_r($_POST);
		// To send HTML mail, the Content-type header must be set
     	$headers  = 'MIME-Version: 1.0' . "\r\n";
     	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
     	$headers .= "From: $this->from_addr\r\n";
		$data['headers'] = $headers;
		$data['subject'] = $_POST['subject'];
		$data['message'] = nl2br($_POST['message']) . 
			"<br/><br/><br/><span style='font-size: 10px'>" . $_POST['footer'] . "</span>";
		$data['address'] = $_POST['address'];
        
        $data['function_email'] = $this->config->item('function_email');

		if ($this->Newsletter_model->sendTest($data)){
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/tick.png'> A single message has been sent.";
		}
		else{
			$message = "<img src='".base_url()."/assets/themes/backoffice/images/cross.png'> A single message has not been sent !!!";		
		}
		echo $message;
	}
	
	public function signUpSheet(){
		$this->load->view('backoffice/newsletter/sign_up_sheet');
	}
	
	public function subscribers($offset=0){
		//setup pagination
		$this->load->library('pagination');
		$config['base_url'] = site_url('backoffice/newsletter/subscribers/');
		$config['total_rows'] = $this->Newsletter_model->get('count=1');
		$config['per_page'] = 50;
		$config['uri_segment'] = 4;
		$config['num_links'] = 4;
		$this->pagination->initialize($config);
		
		$data = array(
			'subscribers'   =>$this->Newsletter_model->get("offset=$offset&limit=$config[per_page]"),
			'pages_links'    =>  $this->pagination->create_links(),
			'total'         =>$this->Newsletter_model->getSubscriberCount(),
			'categories'    => $this->Categories_model->getTreeRows(),
            'sub_nav'       => 'newsletter',
			'view'          => 'newltr_subscribers'
		);

		$this->display('newsletter', 'backoffice', 'none', $data);
	}
	
	/**
	 * Show all items in a category
	 *
	 * @param string $cat_id
	 * @param int $offset
	 */
	public function category($cat_id=null, $offset=0){
		$cat_id = ($cat_id == null) ? $_POST['cat_id'] : $cat_id;
		
		if($cat_id == 'ALL'){
			$this->session->unset_userdata('email_category');
			redirect('backoffice/newsletter/subscribers');
		}
		else {
			$this->session->set_userdata('email_category', $cat_id);
			
			//setup pagination
			$this->load->library('pagination');
			$config['base_url'] = site_url('backoffice/newsletter/category/'.$cat_id);
			$config['total_rows'] = $this->Newsletter_model->get(array('category_in'=>$cat_id,'count'=>TRUE));
			$config['per_page'] = 50;
			$config['uri_segment'] = 5;
			$config['num_links'] = 4;
			$this->pagination->initialize($config);
			
			$data = array(
				'subscribers' => $this->Newsletter_model->get(array('category_in'=>$cat_id,'limit'=>$config['per_page'],'offset'=>$offset)),
				'pages_links' => $this->pagination->create_links(),
				'crumbs' => $this->Categories_model->breadCrumbs($cat_id),
                'sub_nav'=>'newsletter',
				'view' => 'newltr_subscribers'
			);
			
			$this->display('newsletter', 'backoffice', 'none', $data);
		}
	}
}
/* End of file newsletter.php */
/* Location: ./application/modules/backoffice/newsletter.php */
