<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Templates_model
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/15  17:10   Melanie LONTSI KENLAK mel.lontsi@gmail.com
 */
class Templates extends MY_Controller {

	private $template_id;
	private $page;
	private $name;
	private $upload_errors;
   private $desc;
   


	public function __construct(){
 		parent::__construct();
 		
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language'));
		// test if access right Can View
		$this->canView('templates');
		//load models
		if ( !class_exists('Templates_model')) $this->load->model('templates_model');
		$uri = $this->uri->uri_to_assoc(4);

		if (isset($uri['template_id'])) {
			$this->template_id = $uri['template_id'];
		}

		if (isset($uri['name'])) {
			$this->name = $uri['name'];
		}

    }

	public function index($value=NULL) {


		$this->templates = $this->templates_model->get();

		$this->_install_new();

		$data['templates'] = $this->templates_model->get();
		$data['managepresentation'] = 'active';
		$data['templatesettingstyle'] = 'active';
		$data['pagetitle'] = 'CandleCMS ' . $this->lang->line('administration_panel') . ' - ' . $this->lang->line('template_manage');

		//$data['upload_status']=$value;
		$data['sub_nav']='templates';
		$data['view']= 'templates_home';
             
		$this->display('templates', 'backoffice', 'none', $data);
	}

	public function install() {

		$data['managepresentation'] = 'active';
		$data['installtemplatestyle'] = 'active';
		$data['pagetitle'] = 'CandleCMS ' . $this->lang->line('administration_panel') . ' - ' . $this->lang->line('template_install');
		$data['sub_nav']='templates';
        
		if ($_POST) {

			$this->load->helper('install_template');
			$this->_do_upload();
			
			if ( $this->upload_errors) {
				$data['upload_status'] = $this->upload_errors;
				$this->_setMessage($data['upload_status'],"error");
			}
			else {
				$upload_data = $this->upload->data();

				$orig_name=strtolower(substr($upload_data['orig_name'],0,-4));
		

            // check if the file has already been uploaded and installed

			   if(file_exists(getcwd().'/assets/themes/'.$orig_name)){

               $this->load->helper('file');
				   $msg = module_lang('template_already_installed','backoffice');
					delete_files(getcwd().'/assets/uploads/themes/'.$upload_data['file_name']);
					$this->_setMessage($msg,"warning");
			   }
				else if (install_template($upload_data['orig_name'])) {

               $msg = module_lang('template_installed','backoffice');
               $this->desc=$_POST['description'];
               $this->_setMessage($msg,"success");
 				}
				else {
               //PROBLEMS OCCURED WHEN DEPLUGGING THE FILE
					$msg = module_lang('template_not_installed','backoffice');
					$this->_setMessage($msg,"error");
				}
			}
        // var_dump($data['upload_status']);
			redirect("backoffice/templates");
          
		}
		else{

			$data['view']='templates_add';
			$this->display('templates_add', 'backoffice', 'none', $data);
		}
	}


	public function uninstall() {

		$this->templates_model->template_id = $this->template_id;
		$this->templates_model->name=$this->name;
		$id= $this->templates_model->get_default_template();
		$id=$id->template_id;

		if($this->templates_model->template_id == $id){
			 
			   $msg="Cannot delete the default template";
			  $this->_setMessage($msg,"error");
		}
		else{
			
			$this->templates_model->uninstall();

			$this->_setMessage("Delete with success","success");
			redirect('backoffice/templates');
		}
	}

	public function makedefault() {

		$this->templates_model->name =$_POST['theme'];
		$this->templates_model->makedefault();

        //setting the template to be default
		$this->switch_my_theme($_POST['theme']);
		
		$msg= module_lang("default_template_install", "backoffice");
		$this->_setMessage($msg,"success");
		redirect('backoffice/templates');
		
	}

	private function _install_new() {

		foreach ($this->templates as $template) {

			if (!$template['installed'] AND $template['compatible']) {

				$this->templates_model->name = $template['name'];
				$this->templates_model->load_order = $template['load_order'];
				$this->templates_model->description = $this->desc;

				$this->templates_model->install();

			}

		}

	}

	private function _do_upload() {

		$config['upload_path'] =getcwd().'/assets/uploads/themes/';
		$config['allowed_types'] = 'zip';
	//	$config['max_size']	= '5000';

		$this->load->library('upload', $config);


		if ( ! $this->upload->do_upload() ) {
			//upload not done!
			$this->upload_errors = $this->upload->display_errors();
			return FALSE;

		}
		else {

			return TRUE;

		}
	}
}
/* End of file templates.php */
/* Location: ./application/modules/backoffice/templates.php */
