<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Backoffice
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/03  17:10   gabriel gbobard@gmail.com
 */

class Users extends MY_Controller {
	
	function __construct(){
		parent::__construct();
				
		$this->load->model('Usergroups_model');		
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language'));
		// test if access right Can View
		$this->canView('users');

	}
	
	function index($message=NULL){

		if($this->session->userdata('user_level') < 9){
			redirect('backoffice/administrator');
		}
		else {

			$this->load->library('pagination');

			$data = array(
				'users' 	=> $this->Users_model->get_users(array()),
				'page_links'=> $this->pagination->create_links(),
				'message'	=> $message,
				'sub_nav' 	=> 'users',
				'view' 		=> 'users_home'
			);
		if( $data['users']==FALSE)
			redirect('backoffice/administrator/first_login');
		else			
			$this->display('users', 'backoffice', 'none', $data);
			
		}
	}
	
	function edit($user_id=0, $message=NULL){
		
		$this->canEdit('users');
		
		$data = array(
			'user' 	 => $this->Users_model->get_users(array('user_id'=>$user_id))->row_array(),
			'message'	 => $message,
			'usergroups' => $this->Usergroups_model->usergroups,
			'sub_nav'	 => 'users',
			'view'		 => 'user_account'
		);

		$this->display('users', 'backoffice', 'none', $data);
	}
	
	
	
	function activate($user_id){

		$this->Users_model->activate($user_id);
		$message = "Successful update! User Account is now active";
		$this->_setMessage($message, 'success');
		redirect('backoffice/users/');
	}
		
	function save($user_id=NULL){
		if (isset($_POST['email_address']) && $_POST['email_address'] ==NULL) {
			$message = "Account " . (($user_id == NULL) ? 'not created' : ' not updated') . " your email_address is empty.";
		}
		
		if (isset($_POST['password']) && $_POST['password'] ==NULL && $user_id == NULL) {
			$message = "Account " . (($user_id == NULL) ? 'not created' : ' not updated') . " your PassWord is empty.";
		}

		if (isset($message)) {		
			$this->_setMessage($message, 'error');
			redirect('backoffice/users');
		}

		$users = $this->Users_model->get_user_by_email($_POST['email_address']);
		

		if ( $users && $user_id == NULL) {
			$message = "Account not created email_address exist !!!.";
			$this->_setMessage($message, 'error');
			redirect('backoffice/users');
		}

		if(isset($_FILES ['user_image'] ['name']) && $_FILES ['user_image'] ['name'] !=NULL){

			//load photos model
			$this->load->model('Photos_model'); 

			//get default image sizes
			$opts['large_size'] = array ('w' => 100,'h' => 75);
			$opts['upload_path'] = $this->Users_model->getOption('file_upload_path').'users/';
			$opts['allowed_types'] = $this->Photos_model->getOption('image_allowed_types');
						
			//upload the image
			$image_data = $this->_uploadFile( $opts );

			//if successuflly uploaded, add image field to _POST array
			if($image_data[0]['raw_name'] != NULL){
				$_POST['image'] = $image_data[0]['orig_name'];
				$_POST['filename'] = $image_data[0]['raw_name'];
				$_POST['filetype'] = strtolower(substr($image_data[0]['file_ext'], 1));
			}
		}
		
		if($user_id == NULL){// pour s'assurer que nous traitons le cas de la creation d'un compte
			$this->load->helper('string');			
			$code_activation=random_string('alnum',16);
			//var_dump( $_POST['registered'] );die();
			 $_POST['registered']=date('Y-m-d H:i:s', time());
			 $result = $this->Users_model->save($user_id,$code_activation);
	
		}
		else{ //user data update
		    $_POST['lastlogon']=date('Y-m-d H:i:s', time());
			$result = $this->Users_model->save($user_id);
		}
		
		if($result == TRUE){
				
			$message = "Account " . (($user_id == NULL) ? 'created' : 'updated') . " successfully.";
		}
		else {
			$message = "Your operation had some problems.";	
		}
		$this->_setMessage($message, 'success');
		redirect('backoffice/users');
			
	}
	
	function add($message=NULL){
			
		$data = array(
			'user_level' => $this->session->userdata('user_level'),
			'usergroups' => $this->Usergroups_model->usergroups,
			'url' => NULL,
			'about' => NULL,
			'message' => $message,
			'sub_nav' => 'users',
			'view' => 'user_add'
		);

		$this->display('users', 'backoffice', 'none', $data);
	}
	
	function delete($user_id=NULL){

		$this->canDelete('users');

		$result = FALSE;
		$user = $this->Users_model->get_user_by_id($user_id)->display_name;
		//admins only
		if($this->session->userdata('user_level') == 10)
			$result = $this->Users_model->delete($user_id);

		if($result == TRUE){
			$message = "User <b>$user</b> deleted successfully.";
			$this->_setMessage($message, 'success');
		}
		else{
			$message = "User <b>$user</b> is not deleted. There was a problem: $result";
			$this->_setMessage($message, 'error');
		}
		redirect('backoffice/users');
	}

}
/* End of file users.php */
/* Location: ./application/modules/backoffice/users.php */
