<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @author 		BYOOS France - Cameroun - CandleCMS development team
 * @package		CandleCMS
 * @subpackage	Backoffice
 * @category	Application
 * @since 		v0.3.0.50  update  ci-custom2  2.1.1rev16
 *
 * Candlecms controller.
 * update 2011/04/03  17:10   gabriel gbobard@gmail.com
 */

class Usersgroups extends MY_Controller {
	
	function __construct(){
		parent::__construct();
		
		// load the lang module for all controller's backoffice...
		$this->LoadLangModule($this->active_template, $this->session->userdata('language'));
		// test if access right Can View
		$this->canView('users');
			
		$this->load->model('Usergroups_model');		
	}
	
	function index($message=NULL){

		if(!$this->is_admin){
			redirect('backoffice/usersgroups/edit');
		}
		else {

			$this->load->library('pagination');
			
			$config['total_rows']	= $this->Usergroups_model->get_groups_count();
			$config['per_page']		= 10;
			$config['uri_segment']	= 4;
			$config['num_links']	= 4;
			
			$data = array(
				'groups' 	=> $this->Usergroups_model->get_groups(),
				'page_links'=> $this->pagination->create_links(),
				'message'	=> $message,
				'sub_nav' 	=> 'usersgroups',
				'view' 		=> 'all_groups'
			);
				
		$this->display('usersgroups', 'backoffice', 'none', $data);
		}
	}
	
	function edit($group_id, $message=NULL){
		
		$this->canEdit('users');
		
		$data = array(
			'groups' 	 => $groups = $this->Usergroups_model->get_group(array('user_level'=>$group_id))->row(),
			'permissions'=>$this->Usergroups_model->get_module_access($groups->user_level, NULL),
			'message'	 => $message,
			'sub_nav'	 => 'usersgroups',
			'view'		 => 'group_account'
		);

		$this->display('usersgroups', 'backoffice', 'none', $data);
	}
	
	function save($group_id=NULL){

		if($group_id == null)
			$result = $this->Usergroups_model->save_group($group_id);
		else
			$result = $this->Usergroups_model->edit_group($group_id);

		
		if($result === TRUE)
			$message = "Account " . (($group_id == NULL) ? 'created' : 'updated') . " successfully.";
		else
			$message = "Account " . (($group_id == NULL) ? ' not created' : ' not updated') . " group exist !!!.";
			
		$type= ($result===TRUE)? "success":"error";
		$this->_setMessage($message,$type);
		
		if($group_id == null) 
				$this->display('usersgroups', 'backoffice', 'none', array('view'=>'add_user','sub_nav'	 => 'usersgroups', 'message'=>$result));	
		else 
				redirect('backoffice/usersgroups');
	
	}
	
	function add($message=NULL){
			
		$data = array(
			'user_level' => $this->session->userdata('user_level'),
			'message' => $message,
			'sub_nav' => 'usersgroups',
			'view' => 'group_add'
		);

		$this->display('usersgroups', 'backoffice', 'none', $data);
	}
	
	function delete($group){

		$this->canDelete('users');

		//admins only
		if($this->session->userdata('user_level') >= 10)
			$result = $this->Usergroups_model->delete_group($group);
		
		if($result === TRUE)
			$message = "Group $group deleted successfully.";
		else
			$message = "There was a problem: $result";

		$type= ($result===TRUE)? "success":"error";
		$this->_setMessage($message,$type);	
		redirect('backoffice/usersgroups');
	}
	
	function editAccess($grp,$mid){
	
		$view=(isset($_POST['view']) && $_POST['view']==1)? true:false;
		$edit=(isset($_POST['edit']) && $_POST['edit']==1)? true:false;
		$delete=(isset($_POST['delete']) && $_POST['delete']==1)? true:false;

		$this->Usergroups_model->set_module_access($grp,$mid,$edit,$view,$delete);
		
		// update of Access Rights into session and array useraccessright
		$this->useraccessright=$this->UserAccessRight();		
		$message = "Successful your right is update!";
		$this->_setMessage($message, 'success');

		redirect('backoffice/Usersgroups/viewAccess/'.$grp.'/'.$mid);

	}
   
   function viewAccess( $grp,$mid ){

      $data=array(
				'permissions'=>$this->Usergroups_model->get_module_access($grp,$mid)->row(),
				'sub_nav' 	=> 'usersgroups',
				'view' 		=> 'edit_module_access'
			);

			$this->display('usersgroups', 'backoffice', 'none', $data);
   }
}
/* End of file usersgroups.php */
/* Location: ./application/modules/backoffice/usersgroups.php */
