<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class logins_model extends MY_Model {

	var $date;
	var $filename;
	var $ip_address;

	var $page;
	var $limit;
	var $numpages;
	var $paginate;

	public function __construct(){
		parent::MY_Controller();
		$this->limit = 20;
	}

	function get() {

		// before we set a limit / offset, we should grab all results within defined range of records to form number of pages, etc
		$this->_prep_query();
		$query = $this->db->get('inktype_user_logins');
		$this->numpages = ceil($query->num_rows / $this->limit);

		// set the offset and limit for the query
		if ($this->paginate == TRUE) {
			$offset = ($this->page * $this->limit) - $this->limit;
			$this->db->limit($this->limit, $offset);
		}

		$this->_prep_query();
		
		$query = $this->db->get('inktype_user_logins');

		if (isset($this->login_id)) {

			if ($query->row_array()) {

				return $query->row_array();

			}

			else {

				return FALSE;

			}

		}

		else {

			if ($query->result_array()) {

				return $query->result();

			}

			else {

				return FALSE;

			}

		}

	}

	function _prep_query() {
		
		$this->db->select("
		FROM_UNIXTIME(inktype_user_logins.date, '%m/%d/%Y') AS date,
		email_address,
		success AS result");
		
		// this function should only contain anything needed by the query that collects all results for pagination numbers

		$this->db->orderby('date DESC');

	}

}

?>
