<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Forums extends MY_Controller {

	function __construct()
	{
		parent::__construct();

			$this->forums->load->model('Forums_model');
            $this->load->model(array('Categories_model', 'Settings_model'));

	}



	function index($offset=0)
	{
            //all categories with its number of topics

                $this->load->library('pagination');

		$config['per_page'] = 10;
		$config['uri_segment'] = 4;
		$config['num_links'] = 4;


		$config['base_url'] = site_url('forums/forums/page');
		$config['total_rows'] = $this->Forums_model->getAllforums()->num_rows;
		$this->pagination->initialize($config);


                $limit =$config['per_page'];
                $offsett = $offset;


		$data = array(
			'forums' 	=> $this->Forums_model->getForumByCategory($limit,$offsett),
			'logged_in'   =>$this->session->userdata('logged_in'),
             'user_level'   =>$this->session->userdata('userlever'),
            'page_links' 	=> $this->pagination->create_links(),
			'search' 	=> TRUE,
			'view' 		=> 'forums'
		);

		$this->display('forums', $this->active_template, $this->pos_sidebar,  $data);



	}


	/**
	 * Used for pagination. Calls the index() method.
	 *
	 * @param int $offset
	 */
	public function page($offset=0){
		$this->index($offset);
	}


        /**
         *
         * list of topics with pagination
         */
        public function listTopic($id_forum,$offset=0){


            $this->load->library('pagination');

			$config['per_page'] = 10;
			$config['uri_segment'] = 4;
			$config['num_links'] = 4;


            $config['base_url'] = site_url('forums/forums/topic/'.$id_forum);
			$config['total_rows'] = $this->Forums_model->getAllTopic()->num_rows;
			$this->pagination->initialize($config);


                $limit =$config['per_page'];
            $offsett = $offset;


			$data = array(
				'topics' 	=> $this->Forums_model->getTopicByForum($id_forum,$limit,$offsett),
				'forum'         =>  $this->Forums_model->getForum($id_forum),
				'logged_in'   =>$this->session->userdata('logged_in'),                        
				'user_level'   =>$this->session->userdata('userlever'),
				'page_links' 	=> $this->pagination->create_links(),
				'view' 		=> 'topics'
		);

		
              //  var_dump($data['topics']->result_array());

                $this->display('forums', $this->active_template,$this->pos_sidebar,  $data);

        }


        public function topic($id,$offset=0){
				$this->listTopic($id,$offset);
		}
        /*
         *
         * List of Posts with pagination
         */
        public function listPost($id_topic,$offset=0){


                $this->load->library('pagination');

				$config['per_page'] = 10;
				$config['uri_segment'] = 4;
				$config['num_links'] = 4;

                $config['base_url'] = site_url('forums/forums/post/'.$id_topic);
				$config['total_rows'] = $this->Forums_model->getAllPost()->num_rows;
				$this->pagination->initialize($config);


                $limit =$config['per_page'];
               $offsett = $offset;


				$data = array(
					'posts' 	=> $this->Forums_model->getPostByTopic($id_topic),
					'topic'         => $this->Forums_model->getTopic($id_topic),
					'logged_in'   =>$this->session->userdata('logged_in'),
					'user_level'   =>$this->session->userdata('userlever'),
					'page_links' 	=> $this->pagination->create_links(),

					'view' 		=> 'topic_posts'
				);


              //  var_dump($data['posts']->result_array());

                $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);

        }
		
		public function post($id,$offset=0){
				$this->listTopic($id,$offset);
		}
		
        public function  newTopic($id_forum){
		
            if($_POST){
                //insert into the DB the new topic
				
				$this->form_validation->set_rules('topic', 'Topic', 'required');
				$this->form_validation->set_rules('description', 'Description','required' );
				if($this->form_validation->run()==TRUE){
						$new= $_POST;
						$new['forum_id']=$id_forum;
						$new['user_id']=$this->session->userdata('user_id');
						$new['display_name']=$this->session->userdata('display_name');

						$this->Forums_model->saveTopic($new);
                  $this->_setMessage("A new topic has been created", "success")     ;
						$this->listTopic($id_forum);
                  
				}
				else{
					//var_dump("error");
               $this->_setMessage("please,fill all fields", "success")     ;
					
				}

            }
            $data=array(
                    'view'            =>'new_topic',
                    'logged_in'   =>$this->session->userdata('logged_in'),
                    'user_level'   =>$this->session->userdata('userlever'),
                    'forum'         =>  $this->Forums_model->getForum($id_forum)
            );

             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);
        }

        public function sendReply($id_topic){

            if($_POST){
                //insert into the DB the reply
                
                $this->form_validation->set_rules('comment', 'Comment', 'required');
                if($this->form_validation->run()){
						$new= $_POST;
						$new['topic_id']=$id_topic;
						$new['user_id']=$this->session->userdata('user_id');
						$new['display_name']=$this->session->userdata('display_name');

						$this->Forums_model->savePost($new);

                  $this->_setMessage("Comment Saved", "success")     ;
						$this->listPost($id_topic);
				}
				
            }

            $data=array(
                    'view'          =>'new_post',
                    'logged_in'   =>$this->session->userdata('logged_in'),
                    'topic'         =>  $this->Forums_model->getTopic($id_topic)
            );

             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);

        }
       /* public function editPost($id){
				$data=array(
					"post"=>$this->Forums_model->getTopic($id)->row_array(),
			);
			if($data["post"]["user_id"]!=$this->session->userdata('user_id'))
			{
					$this->_setMessage("YOU are not authorised!", "error")     ;
					redirect("forums/forums/listPost/$data[post][id_forum]");
			}
				 if($_POST){
                //insert into the DB the reply
                
                $this->form_validation->set_rules('comment', 'Comment', 'required');
                if($this->form_validation->run()){
						$new= $_POST;
						$new['topic_id']=$id_topic;
						$new['user_id']=$this->session->userdata('user_id');
						$new['display_name']=$this->session->userdata('display_name');

						$this->Forums_model->savePost($new);

                  $this->_setMessage("Comment Saved", "success")     ;
						$this->listPost($id_topic);
				}
				
            }

            $data=array(
                    'view'          =>'new_post',
                    'logged_in'   =>$this->session->userdata('logged_in'),
                    'topic'         =>  $this->Forums_model->getTopic($id_topic)
            );

             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);

			}*/
		public function editTopic($id){
				
			$data=array(
					"topic"=>$this->Forums_model->getTopic($id)->row_array(),
			);
			if(($data["topic"]["user_id"]!=$this->session->userdata('user_id') )||  ($data["topic"]["user_id"]>=9))
			{
					$this->_setMessage("YOU are not authorised!", "error")     ;
					//redirect("forums/forums/listTopic/$data[topic][forum_id]");
			}
		//	var_dump($data);die();
			$id_forum=$data["topic"]["id_forum"];
			if($_POST){
                
				
				$this->form_validation->set_rules('topic', 'Topic', 'required');
				$this->form_validation->set_rules('description', 'Description','required' );
				if($this->form_validation->run()==TRUE){
						$update= $_POST;
						
						$update['id_topic']=$id;
						
						$this->Forums_model->saveTopic($update);
                  $this->_setMessage("the topic has been updated", "success")     ;
						$this->listTopic($id_forum);
                  
				}
				else{
					//var_dump("error");
               $this->_setMessage("please,fill all fields", "success")     ;
					
				}
			}

			$data['view']            ='new_topic';
          $data['logged_in' ]            =$this->session->userdata('logged_in');
          $data[ 'user_level' ]           =$this->session->userdata('userlever');
             $data['forum' ]               = $this->Forums_model->getForum($id_forum);
           

             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);
		}		

}
