<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');


class Moderator extends MY_Controller {

    
    public function __construct(){

	parent::__construct();

        $this->forums->load->model('Forums_model');
        $this->load->model('usergroups_model');			
        
        
        $this->admin_level = $this->usergroups_model->get_group_by_name('Administrator');	
        	
        if ($this->session->userdata('user_level') < $this->admin_level) { // Administrator
			redirect('backoffice/administrator/doLogin');
		}
	
    }
	
	/**
	 * Index
	 *
	 * Lists categories with number of topics.
	 *
	 * @access	public
	 * @return	void
	 */
	public function index()
	{
		redirect('forums/forums/');

      
	}

	/**
	 * Create Category
	 *
	 * Displays a form to create a category.
	 * Creates the category if it passes form validation.
	 *
	 * @todo	Check for duplicate categories.
	 * @access	public
	 * @return	void
	 */
	public function editcategory($id=0)
	{
		$data=array();
		if($id>0){
			$data['category']=$this->Forums_model->getAllCategory($id)->row_array();
		}
			
		if($_POST){
			
			$this->form_validation->set_rules('title', 'Title', 'required');
			if($this->form_validation->run()){
				
                $this->Forums_model->saveCategory($id);
                $this->_setMessage("A  category has been saved", "success")     ;
          
                
               ($id == NULL || $id == 0)?redirect('forums/moderator/editforum') : redirect('forums/forums');
					
                
            }
            else
               $this->_setMessage("Fill all fields please", "error")     ;
        }
        
        
          $data[ 'view'        ]   ='new_category';
          $data['logged_in']   =$this->session->userdata('logged_in');
          $data['user_level' ]  =$this->session->userdata('userlever');
                    
        

             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);

	}

	
	/**
	 * Create Forum
	 *
	 * Displays a form to create a forum.
	 * Creates the forum if it passes form validation.
	 *
	 * @todo	Check for duplicate forums.
	 * @access	public
	 * @return	void
	 */
	public function editforum($id=0)
	{
		$data=array();
		if($id>0){
			$data['forums']=$this->Forums_model->getForum($id)->row_array();
		}

		if($_POST){
			$this->form_validation->set_rules('forum_name', 'Forum', 'required');
			$this->form_validation->set_rules('forum_desc', 'Description', 'required');
			if($this->form_validation->run()){
				
                       $this->Forums_model->saveForum($id);
                       $this->_setMessage("A forum has been saved", "success")     ;
                       redirect('forums/forums/');
             }
             else
                $this->_setMessage("Fill all fields please", "error")     ;
         }
        
			$data['category']		     =$this->Forums_model->getAllCategory();
        $data['view']	          ='new_forum';
          $data['logged_in']	  =$this->session->userdata('logged_in');
         $data['user_level']	   =$this->session->userdata('userlever');
     
             $this->display('forums', $this->active_template, $this->pos_sidebar,  $data);
	}


	/**
	 * Delete
	 *
	 * This deletes both categories and forums (based on $type).
	 * It recursivly deletes all children.
	 *
	 * @param	string	The type of item to delete.
	 * @param	int		The id of the category or forum to delete.
	 * @access	public
	 * @return	void
	 */
	

	
	public function delete($type, $id)
	{
		$this->Forums_model->delete($type,$id);
      $this->_setMessage("Deletion Complete", "success")     ;
      redirect('forums/forums/');
	}
	public function edit($id=null)
	{


	}
}
?>
