<?php if (!defined('BASEPATH')) exit('No direct script access allowed');



class Forums_model extends MY_Model{


    // exemple integrated into SQL  `' . $this->db->dbprefix($this->table) . '`



    public $forum_topic  = 'forums_topic';
    public $forum_cat    = 'forums_categories';
    public $forum_comment= 'forums_comments';
    public $forum_for    = 'forums_forum';
    public $tab_users    = 'users';


    public function  __construct() {
        parent::__construct();
    }

    /*
     *
     *
     * search a topic ,return the topic id ,its title and its author
     */

    public function searchForumTopic($search_str){
	$q = 'SELECT f.id,f.topic , f.display_name
		FROM `' . $this->db->dbprefix($this->forum_topic) . '` f
		WHERE MATCH (f.topic) AGAINST ("' . $search_str . '")
		ORDER BY timestamp DESC';
	return $this->db->query($q);
    }

    /**
     *
     * @param <type> $datas_cat
     * insert a new category
     */
    public function saveCategory($id){
		if($id == NULL || $id == 0){
         $this->db->insert($this->db->dbprefix($this->forum_cat), $_POST);
        }else{

				$this->db->where('id_cat', $id);
               $this->db->update($this->db->dbprefix($this->forum_cat), $_POST);
			 }
				
    }

    public function saveForum($id){
		if($id == NULL || $id == 0){
			$this->db->insert($this->db->dbprefix($this->forum_for), $_POST);
		}
		else{
			$this->db->where('id_forum', $id);
         $this->db->update($this->db->dbprefix($this->forum_for), $_POST);
		}
    }


    
    /*
     *
     * insert or update a topic
     */

    public function saveTopic($topic){
//		 var_dump($topic);die();
		if(isset($topic['id_topic'] )){
		//	unset($topic['id']);
			$this->db->where('id_topic', $topic['id_topic']);
         $this->db->update($this->db->dbprefix($this->forum_topic), $topic);
		}
		else
        return$this->db->insert($this->db->dbprefix($this->forum_topic), $topic);

         

    }


   
    /*
     *
     * Get all topics,returns the topic title, its category its author and its number of posts
     
*/
    public function getAlltopics(){
        
        $query='SELECT top.id_topic,top.user_id, top.topic, top.display_name, f.forum_name
                FROM `' . $this->db->dbprefix($this->forum_topic) . '` top
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_for) . '` f ON f.id_forum = top.forum_id
                GROUP BY f.forum_name
                ORDER BY top.timestamp DESC';
      return   $this->db->query($query);
        
    }

    /*
     * returns all forum name group by category
     */

    
    public function getForumByCategory($limit=NULL,$offset=NULL){

      $query='SELECT cat.id_cat,cat.title ,f.id_forum, f.forum_name,f.forum_desc , count(distinct top.topic) nbrtop, count(post.comment) nbrpost
                FROM `' . $this->db->dbprefix($this->forum_for) .'` f
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_cat) . '` cat ON  f.category_id = cat.id_cat
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_topic) . '` top ON  f.id_forum = top.forum_id
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_comment) . '` post ON  top.id_topic =post.topic_id
                GROUP BY  cat.id_cat,f.forum_name
                LIMIT '.$offset .',' .$limit;

      return   $this->db->query($query);

    }

   
    
    /*
     *
     * Save a new post (reply for  a topic)
     */

    public function savePost($datas){
         $this->db->insert($this->db->dbprefix($this->forum_comment), $datas);
    }

    /*
     *
     * count the number of posts of a topic
     */
    public function countPostTopic($id){

            $this->db->where("topic_id = $id");
            $this->db->from( $this->db->dbprefix($this->forum_comment));
           return  $this->db->count_all_results();


    }
    /**
     *
     * @param <type> $user_id
     * @return <type>
     *
     * count the number of posts of an user
     */
    public function countPostByUser($user_id){

            $this->db->where("user_id = $user_id");
            $this->db->from( $this->db->dbprefix($this->forum_comment));
           return  $this->db->count_all_results();

    }

    /*
     *
     * count the number of topic in a Forum 's category
     */
    public function countTopicForum($id_for){


            $this->db->where(array('forum_id' => $id_for));
            $this->db->from( $this->db->dbprefix($this->forum_topic));
           return  $this->db->count_all_results();

    }
    /*
     *
     * get all posts of a topic
     */
    public function getPostByTopic($id_topic){

        $this->db->where(array('topic_id' => $id_topic));
	$this->db->order_by('timestamp desc');

	return $this->db->get($this->db->dbprefix($this->forum_comment));
    }
    /*
     * get all categories
     */
    public function getAllCategory($id=null){
		 if(isset($id))
				$this->db->where(array('id_cat' => $id));
       return $this->db->get($this->db->dbprefix($this->forum_cat));
    }
    /*
     * get all posts
     */
    public function getAllPost(){
          return $this->db->get($this->db->dbprefix($this->forum_comment));
    }


    /*
     * get all topics
     */
    public function getAllTopic(){
          return $this->db->get($this->db->dbprefix($this->forum_topic));
    }
    /*
     * get all forums
     */
    public function getAllforums(){
          return $this->db->get($this->db->dbprefix($this->forum_for));
    }


    /*
     *
     * Get topics by Forum 's name
     */
    public function getTopicByForum($id_forum){

         $query='SELECT top.id_topic, top.user_id,top.topic,top.description, top.display_name, count(com.comment) nbrpost
                FROM `' . $this->db->dbprefix($this->forum_topic) . '` top
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_comment) . '` com ON com.topic_id = top.id_topic
                WHERE top.forum_id ='.$id_forum .'
                GROUP BY top.id_topic    ' ;

            return  $this->db->query($query);

    }
/*
 *
 * return  the topic + its forum's name +its category
 * Category>>Forum>>Topic
 */

    public function getTopic($id){
        
        $query='SELECT top.id_topic,top.user_id,top.topic,top.description,cat.title,f.id_forum,f.forum_name
                FROM `' . $this->db->dbprefix($this->forum_topic) . '` top
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_for) . '` f ON f.id_forum = top.forum_id
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_cat) . '` cat ON cat.id_cat = f.category_id
                WHERE top.id_topic ='.$id ;
           

            return  $this->db->query($query);
    }
   /**
    *
    *Category>>Forum
    */
    public function getForum($id){

        $query='SELECT cat.title,f.id_forum,f.forum_name,f.forum_desc
                FROM `' . $this->db->dbprefix($this->forum_for) . '` f
                LEFT OUTER JOIN `' . $this->db->dbprefix($this->forum_cat) . '` cat ON cat.id_cat = f.category_id
                WHERE f.id_forum ='.$id ;


            return  $this->db->query($query);
    }
   
/**
 *
 * delete category ,forum,topic, post
 */
    public function delete($type, $id)
	{
		switch ($type) {
			// Delete the category
			case 'category':
            
            //on recupere tous les forums dont la categorie est $id
              $query='select f.id_forum from `' . $this->db->dbprefix($this->forum_for) . '` f where category_id='.$id;
              $forum= $this->db->query($query);

      
               if($forum->num_rows() >0){
                   $i=0;
                   foreach ($forum->result_array() as $key=>$t ) {
                        $forum_id[$i]=$t['id_forum'];
                        $i++;
                    }
            
                   //on recupere tous les topics des forums de categorie $id
                   $this->db->where_in('forum_id',$forum_id);
                   $this->db->select("id_topic");
                   $topic=  $this->db->get($this->db->dbprefix($this->forum_topic));


                   if($topic->num_rows() > 0){
                      $i=0;
                      foreach ($topic->result_array() as $key=>$t ) {
                        $topic_id[$i]=$t['id_topic'];
                        $i++;
                    }
                    //on supprime les commentaires

                     $this->db->where_in('topic_id',$topic_id);
                      $this->db->delete($this->db->dbprefix($this->forum_comment));


                   }
                   //on supprime les topics
                   $this->db->where_in('forum_id',$forum_id);
                   $topic= $this->db->delete($this->db->dbprefix($this->forum_topic));



                }
                //on supprime les forums de cette categorie
               $this->db->delete($this->db->dbprefix($this->forum_for), array('category_id'=>$id));

               //on supprime maintenant la categorie en question
              return $this->db->delete($this->db->dbprefix($this->forum_cat), array('id_cat'=>$id));


            
				break;

			// Delete the forum
			case 'forum':
               //on recupere tous les topics du forum $id
              $query='select top.id_topic from `' . $this->db->dbprefix($this->forum_topic) . '` top where forum_id='.$id;
              $where= $this->db->query($query);

            
               if($where->num_rows()>0){
                   $i=0;
                   foreach ($where->result_array() as $key=>$t ) {
                        $topic_id[$i]=$t['id_topic'];
                        $i++;
                    }
                    //on supprime tous les posts des topics du forum $id
                   $this->db->where_in('topic_id',$topic_id);
                   $this->db->delete($this->db->dbprefix($this->forum_comment));       
             
                }
               $this->db->delete($this->db->dbprefix($this->forum_topic), array('forum_id'=>$id));
              return $this->db->delete($this->db->dbprefix($this->forum_for), array('id_forum'=>$id));

              
				break;

			case 'topic':

               $this->db->delete($this->db->dbprefix($this->forum_comment), array('topic_id'=>$id));
              return $this->db->delete($this->db->dbprefix($this->forum_topic), array('id_topic'=>$id));

          break;

         case 'post':
            
              return $this->db->delete($this->db->dbprefix($this->forum_comment), array('id_comment'=>$id));
            break;
         default:
				break;
		}
	}


   /*
    *
    *
    * update category,forum,topic,post
    */
   public function update($type,$id){
      
      switch ($type) {

			// update category
			case 'category':

               $this->db->where('id_cat', $id);
               $this->db->update($this->db->dbprefix($this->forum_cat), $_POST);


				break;

			// update forum
			case 'forum':
               $this->db->where('id_forum', $id);
               $this->db->update($this->db->dbprefix($this->forum_for), $_POST);

				break;

			case 'topic':
               $this->db->where('id_topic', $id);
               $this->db->update($this->db->dbprefix($this->forum_topic), $_POST);



          break;

         case 'post':
               $this->db->where('id_comment', $id);
               $this->db->update($this->db->dbprefix($this->forum_comment), $_POST);


            break;
         default:
				break;
   }
  }



}







?>
