/*
DROP TABLE IF EXISTS `__DBPREFIX__captcha`;
DROP TABLE IF EXISTS `__DBPREFIX__categories`;
DROP TABLE IF EXISTS `__DBPREFIX__newsletter`;
DROP TABLE IF EXISTS `__DBPREFIX__email_pending`;
DROP TABLE IF EXISTS `__DBPREFIX__events`;
DROP TABLE IF EXISTS `__DBPREFIX__links`;
DROP TABLE IF EXISTS `__DBPREFIX__locations`;
DROP TABLE IF EXISTS `__DBPREFIX__medias`;
DROP TABLE IF EXISTS `__DBPREFIX__items`;
DROP TABLE IF EXISTS `__DBPREFIX__item_images`;
DROP TABLE IF EXISTS `__DBPREFIX__item_sizes`;
DROP TABLE IF EXISTS `__DBPREFIX__options`;
DROP TABLE IF EXISTS `__DBPREFIX__pages`;
DROP TABLE IF EXISTS `__DBPREFIX__photos`;
DROP TABLE IF EXISTS `__DBPREFIX__posts`;
DROP TABLE IF EXISTS `__DBPREFIX__classifieds`;
DROP TABLE IF EXISTS `__DBPREFIX__classified_comments`;
DROP TABLE IF EXISTS `__DBPREFIX__posts_comments`;
DROP TABLE IF EXISTS `__DBPREFIX__tags`;
DROP TABLE IF EXISTS `__DBPREFIX__contacts`;
DROP TABLE IF EXISTS `__DBPREFIX__visitor_activity`;
DROP TABLE IF EXISTS `__DBPREFIX__ci_sessions`;
DROP TABLE IF EXISTS `__DBPREFIX__langages`;
DROP TABLE IF EXISTS `__DBPREFIX__settings`;
DROP TABLE IF EXISTS `__DBPREFIX__users`;
DROP TABLE IF EXISTS `__DBPREFIX__users_login`;
DROP TABLE IF EXISTS `__DBPREFIX__users_meta`;
DROP TABLE IF EXISTS `__DBPREFIX__groups`;
DROP TABLE IF EXISTS `__DBPREFIX__visitors`;
DROP TABLE IF EXISTS `__DBPREFIX__modules`;
DROP TABLE IF EXISTS `__DBPREFIX__groups_modules_access`
version 0.9.8.6 update 2012/10/15  15:30  BYOOS solutions Cameroun gabriel gbobard@gmail.com

*/

CREATE TABLE IF NOT EXISTS `__DBPREFIX__captcha` (
  `captcha_id` bigint(13) unsigned NOT NULL auto_increment,
  `captcha_time` int(10) unsigned NOT NULL,
  `ip_address` varchar(16) NOT NULL default '0',
  `word` varchar(20) NOT NULL,
  PRIMARY KEY  (`captcha_id`),
  KEY `word` (`word`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__categories` (
  `id` int(11) NOT NULL auto_increment,
  `cat_type` varchar(100) NOT NULL,
  `category` varchar(500) NOT NULL,
  `descrip` varchar(1000) default NULL,
  `color` varchar(50) default NULL,
  `private` varchar(10) default NULL,
  `slug` varchar(100) default NULL,
  `parent` int(11) NOT NULL default '0',
  `lft` int(11) NOT NULL default '0',
  `rgt` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__newsletter` (
  `id` int(11) NOT NULL auto_increment,
  `address` varchar(200) default NULL,
  `registered` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `last_email_sent` timestamp NULL default NULL,
  `last_email_status` varchar(500) default NULL,
  `active` varchar(50) default NULL,
  `category` int(11) NULL default '0',
  `fail_cnt` int(11) NOT NULL default '0',
  `success_cnt` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__email_pending` (
  `id` int(11) NOT NULL auto_increment,
  `to_address` varchar(200) NOT NULL,
  `from_address` varchar(200) default NULL,
  `headers` varchar(5000) default NULL,
  `subject` varchar(1000) default NULL,
  `message` varchar(10000) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__events` (
  `id` int(11) NOT NULL auto_increment,
  `start_timestamp` timestamp NOT NULL default '0000-00-00 00:00:00',
  `end_timestamp` timestamp NOT NULL default '0000-00-00 00:00:00',
  `title` varchar(200) default NULL,
  `descrip` varchar(1000) default NULL,
  `location` int(11) NOT NULL,
  `category` int(11) NOT NULL,
  `image` varchar(200) default NULL,
  `added_by` varchar(100) default NULL,
  `added_timestamp` timestamp NOT NULL default '0000-00-00 00:00:00',
  `modified_by` varchar(50) default NULL,
  `modified_timestamp` timestamp NOT NULL default '0000-00-00 00:00:00' on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__links` (
  `id` int(11) NOT NULL auto_increment,
  `url` varchar(255) NOT NULL,
  `name` varchar(255) default NULL,
  `email_address` varchar(50) default NULL,
  `image` varchar(255) default NULL,
  `image_url` varchar(255) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `rss_url` varchar(255) default NULL,
  `target` varchar(10) default NULL,
  `category` int(11) NOT NULL default '0',
  `private` varchar(5) NOT NULL default 'false',
  `descrip` varchar(1023) default NULL,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `descrip` (`descrip`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__locations` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(500) default NULL,
  `descrip` varchar(5000) default NULL,
  `addr1` varchar(100) default NULL,
  `addr2` varchar(100) default NULL,
  `city` varchar(100) default NULL,
  `state` varchar(2) default NULL,
  `zip` varchar(10) default NULL,
  `phone` varchar(100) default NULL,
  `latlon` varchar(100) default NULL,
  `link` varchar(500) default NULL,
  `map` varchar(2000) default NULL,
  `image` varchar(100) default NULL,
  `category` varchar(100) default NULL,
  `private` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__medias` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(50) default NULL,
  `filetype` varchar(50) default NULL,
  `filename` varchar(255) default NULL,
  `filesize` varchar(50) default NULL,
  `category` int(11) NOT NULL default '0',
  `title` varchar(255) default NULL,
  `descrip` varchar(1023) default NULL,
  `date_uploaded` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `imagesize` varchar(127) default NULL,
  `downloaded` int(5)       NOT NULL default 0, 
  `allowdownload` tinyint(1) default 0,
  
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__items` (
  `id` int(11) NOT NULL auto_increment,
  `merchid` varchar(100) default NULL,
  `description` varchar(1000) default NULL,
  `shortdesc` varchar(100) default NULL,
  `title` varchar(100) default NULL,
  `price` float default NULL,
  `quantity` int(11) default NULL,
  `shipping` float default NULL,
  `tax` float default NULL,
  `date` timestamp NULL default NULL,
  `category` varchar(100) default NULL,
  `category2` varchar(100) default NULL,
  `extra` varchar(1000) default NULL,
  `image` varchar(100) default NULL,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `title_2` (`title`,`shortdesc`,`description`,`extra`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__item_images` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) default NULL,
  `imageid` varchar(100) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `main` varchar(20) default NULL,
  `size` varchar(100) default NULL,
  `date` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__item_sizes` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) default NULL,
  `size` varchar(100) default NULL,
  `description` varchar(1000) default NULL,
  `price` float default NULL,
  `tax` float default '0',
  `weight` float default '0',
  `shipping` float default '0',
  `handling` float default '0',
  `available` int(11) default '0',
  `date` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__options` (
  `id` int(11) NOT NULL auto_increment,
  `category` varchar(100) default NULL,
  `option_name` varchar(1000) NOT NULL,
  `descrip` varchar(1000) default NULL,
  `option_value` varchar(5000) default NULL,
  `autoload` varchar(100) NOT NULL default 'false',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__pages` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `user_id` int(11) NOT NULL  default 0,
  `display_name` varchar(50) NOT NULL,
  `lang` varchar(255) NOT NULL default 'en',
  `status` varchar(100) default 'Published',
  `title` varchar(1000) default NULL,
  `detail` text,
  `slug` varchar(255) default NULL,
  `category` varchar(100) default NULL,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `detail` (`detail`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__photos` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(50) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `filesize` varchar(50) default NULL,
  `category` varchar(100) default NULL,
  `slug` varchar(255) DEFAULT NULL,
  `picturetitle` varchar(50) default NULL,
  `date_uploaded` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `date_taken` timestamp NULL default NULL,
  `imagesize` varchar(100) default NULL,
  `views` int(11) default NULL,
  `numofratings` int(11) default NULL,
  `rating` int(11) default NULL,
  `comments` varchar(50000) default NULL,
  `keywords` varchar(1000) default NULL,
  `make` varchar(100) default NULL,
  `model` varchar(500) default NULL,
  `aperture` varchar(100) default NULL,
  `exposure` varchar(100) default NULL,
  `flash` varchar(100) default NULL,
  `focal_length` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__posts` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `user_id` int(11) NOT NULL default 0,
  `display_name` varchar(50) NOT NULL,
  `lang` varchar(255) NOT NULL default 'en',
  `status` varchar(100) default 'published',
  `title` varchar(1000) default NULL,
  `summary` varchar(5000) default NULL,
  `detail` varchar(10000) default NULL,
  `image` varchar(255) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `allow_comments` varchar(100) default NULL,
  `comment_email_notify` varchar(100) default NULL,
  `slug` varchar(255) default NULL,
  `tags` varchar(1000) default NULL,
  `category` varchar(100) default NULL,
  `service` varchar(100) default NULL,
  `service_id` varchar(100) default NULL,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `detail` (`detail`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__classifieds` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `user_id` int(11) NOT NULL default 0,
  `email_address` varchar(50) NOT NULL,
  `display_name` varchar(50) NOT NULL,
  `lang` varchar(255) NOT NULL default 'en',
  `status` varchar(100) default 'published',
  `title` varchar(1000) default NULL,
  `summary` varchar(5000) default NULL,
  `detail` varchar(10000) default NULL,
  `image` varchar(255) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `allow_answers` varchar(100) default NULL,
  `answer_email_notify` varchar(100) default NULL,
  `slug` varchar(255) default NULL,
  `tags` varchar(1000) default NULL,
  `category` varchar(100) default NULL,
  `service` varchar(100) default NULL,
  `service_id` varchar(100) default NULL,
  PRIMARY KEY  (`id`),
  FULLTEXT KEY `detail` (`detail`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__classified_answers` (
  `id` int(11) NOT NULL auto_increment,
  `classified_id` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `name` varchar(100) NOT NULL,
  `url` varchar(500) default NULL,
  `email` varchar(100) default NULL,
  `answer` varchar(5000) NOT NULL,
  `ip` varchar(100) default NULL,
  `approved` varchar(100) default 'true',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__post_comments` (
  `id` int(11) NOT NULL auto_increment,
  `post_id` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `name` varchar(100) NOT NULL,
  `url` varchar(500) default NULL,
  `email` varchar(100) default NULL,
  `comment` varchar(5000) NOT NULL,
  `ip` varchar(100) default NULL,
  `approved` varchar(100) default 'true',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__tags` (
  `id` int(11) NOT NULL auto_increment,
  `src_id` int(11) NOT NULL,
  `tag_type` varchar(100) NOT NULL,
  `tag` varchar(500) NOT NULL,
  `descrip` varchar(1000) default NULL,
  `slug` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__contacts` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `email` varchar(100) default NULL,
  `timestamp` timestamp NULL default NULL,
  `category` varchar(100) default NULL,
  `url` varchar(200) default NULL,
  `about` varchar(5000) default NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__visitor_activity` (
  `id` int(11) NOT NULL auto_increment,
  `timestamp` timestamp NULL default CURRENT_TIMESTAMP,
  `ip` varchar(127) default NULL,
  `uri` varchar(255) default NULL,
  `agent_type` varchar(10) default NULL,
  `agent_name` varchar(255) default NULL,
  `agent_version` varchar(127) default NULL,
  `agent_string` varchar(1023) default NULL,
  `referrer` varchar(1023) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- command split --

CREATE TABLE IF NOT EXISTS  `__DBPREFIX__ci_sessions` (
	session_id varchar(40) DEFAULT '0' NOT NULL,
	ip_address varchar(16) DEFAULT '0' NOT NULL,
	user_agent varchar(120) NOT NULL,
	last_activity int(10) unsigned DEFAULT 0 NOT NULL,
	user_data text NOT NULL,
	PRIMARY KEY (session_id),
	KEY `last_activity_idx` (`last_activity`)
);

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__languages` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `code` char(5) DEFAULT NULL,
  `name` varchar(100) DEFAULT '',
  `image` varchar(255) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `ordering` int(5) DEFAULT '0',
  `active` tinyint(1) DEFAULT '1',
  `is_default` tinyint(2) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `code` (`code`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__settings` (
  `setting_id` int(11) NOT NULL auto_increment,
  `blog_id` int(11) NOT NULL,
  `blog_title` varchar(255) NOT NULL,
  `blog_description` varchar(255) NOT NULL,
  `allow_register` int(1) NOT NULL default '1',
  `allow_comments` int(1) NOT NULL default '1',
  `default_category` int(1) NOT NULL default '0',
  `default_page_id` varchar(255) NOT NULL,
  `enabled` int(1) NOT NULL default '1',
  PRIMARY KEY  (`setting_id`),
  KEY `blogid` (`blog_id`),
  KEY `enabled` (`enabled`),
  KEY `default_page_id` (`default_page_id`),
  KEY `default_category` (`default_category`),
  KEY `allow_comments` (`allow_comments`),
  KEY `allow_register` (`allow_register`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__users` (
  `user_id` int(11) NOT NULL auto_increment,
  `email_address` varchar(50) NOT NULL,
  `password` varchar(50) NOT NULL,
  `display_name` varchar(50) NOT NULL,
  `last_name` varchar(50) DEFAULT NULL,
  `first_name` varchar(50) DEFAULT NULL,
  `mobile_phone` varchar(20) DEFAULT NULL,
  `salt` varchar(5) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_level` int(2) DEFAULT NULL,
  `active` int(1) DEFAULT NULL,
  `activation_code` varchar(40) COLLATE utf8_unicode_ci DEFAULT NULL,
  `registered` timestamp NOT NULL default '0000-00-00 00:00:00',
  `lastlogon` timestamp NOT NULL default '0000-00-00 00:00:00',
  `admin` int(1) DEFAULT NULL,
  `image` varchar(255) default NULL,
  `filename` varchar(50) default NULL,
  `filetype` varchar(4) NOT NULL DEFAULT 'jpg',
  `url` varchar(200) default NULL,
  `about` varchar(5000) default NULL,
  `reset_key` varchar(100) default NULL,
  `u_group_id` int(11) DEFAULT NULL,
  PRIMARY KEY  (`user_id`),
    KEY `email_address` (`email_address`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__user_logins` (
  `user_login_id` int(11) NOT NULL auto_increment,
  `email_address` varchar(255) NOT NULL,
  `success` int(1) NOT NULL,
  `date` varchar(12) NOT NULL,
  PRIMARY KEY  (`user_login_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__user_meta` (
  `user_meta_id` int(11) NOT NULL auto_increment,
  `user_id` int(5) NOT NULL,
  `meta_key` varchar(45) NOT NULL,
  `meta_value` varchar(255) NOT NULL,
  PRIMARY KEY  (`user_meta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__visitors` (
  `visitor_id` int(11) NOT NULL auto_increment,
  `date` varchar(25) NOT NULL,
  `ip_address` varchar(25) NOT NULL,
  `browser` varchar(50) NOT NULL,
  `referer` varchar(255) NOT NULL,
  `page_visited` varchar(255) NOT NULL,
  `human_year` varchar(4) NOT NULL,
  `human_month` varchar(2) NOT NULL,
  `human_day` varchar(2) NOT NULL,
  PRIMARY KEY  (`visitor_id`),
  KEY `human_year` (`human_year`),
  KEY `human_month` (`human_month`),
  KEY `human_day` (`human_day`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__templates` (
  `template_id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `load_order` varchar(255) NOT NULL,
  `sidebar` varchar(10) default 'none',
  `description` varchar(255) default NULL,
  `is_default` int(1) NOT NULL default '0',
  PRIMARY KEY  (`template_id`),
  KEY `is_default` (`is_default`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__forums_categories` (
  `id_cat` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50)  NOT NULL,
  PRIMARY KEY (`id_cat`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8  AUTO_INCREMENT=6 ;


-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__forums_comments` (
  `id_comment` int(11) NOT NULL AUTO_INCREMENT,
  `topic_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `display_name` varchar(30)  NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `comment` varchar(5000)  NOT NULL,
  PRIMARY KEY (`id_comment`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8  AUTO_INCREMENT=3 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__forums_forum` (
  `id_forum` int(11) NOT NULL AUTO_INCREMENT,
  `category_id` int(11) NOT NULL,
  `forum_name` varchar(50)  NOT NULL,
  `forum_desc` varchar(1000)  NOT NULL,
  `forum_last_post_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id_forum`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__forums_topic` (
  `id_topic` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `display_name` varchar(30)  NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `topic` varchar(100)  NOT NULL,
  `description` varchar(1000)  NOT NULL,
  `forum_id` int(11) NOT NULL,
  `topic_last_post_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id_topic`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8  AUTO_INCREMENT=3 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__modules` (
  `mid` int(11) NOT NULL AUTO_INCREMENT,
  `controller` varchar(100) NOT NULL,
  `name` varchar(100) NOT NULL,
  `display_name` varchar(100) NOT NULL,
  `description` varchar(1000) NOT NULL,
  `version` varchar(10) NOT NULL,
  `type` varchar(100) NOT NULL,
  `isinstalled` tinyint(2) NOT NULL,
  `isactive` tinyint(2) NOT NULL,
  `isvisible` tinyint(2) NOT NULL,
  `icon` varchar(100) DEFAULT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `mod_order` int(11) NOT NULL,
  PRIMARY KEY (`mid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=16 ;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__groups` (
  `group_id` tinyint(3) NOT NULL auto_increment,
  `user_level` int(2) DEFAULT NULL,
  `group_name` varchar(255) NOT NULL,
  `description` varchar(255) default NULL,
  `login_redirect` varchar(255) default NULL,
  `logout_redirect` varchar(255) default NULL,
  `active` int(1) default NULL,
  `registered` timestamp NULL default NULL,
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12;

-- command split --

CREATE TABLE IF NOT EXISTS `__DBPREFIX__groups_modules_access` (
  `grpma_id` int(11) NOT NULL AUTO_INCREMENT,
  `grpma_edit` tinyint(4) DEFAULT NULL,
  `grpma_view` tinyint(4) DEFAULT NULL,
  `grpma_delete` tinyint(4) DEFAULT NULL,
  `grp_id` int(8) NOT NULL,
  `mid` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`grpma_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=83 ;

