INSERT INTO `__DBPREFIX__users` (`user_id`, `email_address`, `password`, `display_name`, `last_name`, `first_name`, `salt`, `registered`, `lastlogon`, `admin`, `image`, `url`, `about`, `reset_key`, `active`,  `user_level`,`u_group_id`) VALUES
( '', '__EMAIL__', '__PASSWORD__', '__USERNAME__', '__LASTNAME__', '__FIRSTNAME__', '__SALT__', '__NOW__', NULL, 1, NULL, NULL, '', NULL, '1', 1001,1);

-- command split --

CREATE VIEW __DBPREFIX__events_view AS (
SELECT __DBPREFIX__events.id, __DBPREFIX__events.start_timestamp, __DBPREFIX__events.end_timestamp, DAY( start_timestamp ) start_day, __DBPREFIX__events.title, __DBPREFIX__events.descrip, __DBPREFIX__events.image, __DBPREFIX__categories.category, coalesce(__DBPREFIX__categories.color, '#555555') color, __DBPREFIX__categories.private, __DBPREFIX__categories.id cat_id, __DBPREFIX__categories.slug cat_slug,
__DBPREFIX__locations.name, __DBPREFIX__locations.addr1, __DBPREFIX__locations.city, __DBPREFIX__locations.state, __DBPREFIX__locations.zip, __DBPREFIX__locations.link
FROM __DBPREFIX__events
LEFT OUTER JOIN __DBPREFIX__categories ON __DBPREFIX__events.category = __DBPREFIX__categories.id
LEFT OUTER JOIN __DBPREFIX__locations ON __DBPREFIX__events.location = __DBPREFIX__locations.id
);

-- command split --

CREATE VIEW __DBPREFIX__items_view AS (
SELECT i.id, i.merchid, i.title, i.description, i.shortdesc, i.date, i.extra, i.category2, coalesce( c.category, 'Uncategorized' ) category, coalesce( c.slug, 'uncategorized' ) cat_slug, c.id cat_id, img.imageid, img.filename, img.filetype, (
SELECT sum( available )
FROM __DBPREFIX__item_sizes
WHERE itemid = i.id
)available
FROM __DBPREFIX__items i
LEFT OUTER JOIN __DBPREFIX__categories c ON c.id = i.category
LEFT OUTER JOIN __DBPREFIX__item_images img ON img.itemid = i.id
AND img.main = 'true' 
);

-- command split --

CREATE VIEW __DBPREFIX__posts_view AS (
SELECT p.id, p.timestamp, DATE_FORMAT( p.timestamp, '%b %e, %Y' ) f_date, DATE_FORMAT( p.timestamp, '%l:%i%p' ) f_time, p.user_id, coalesce(u.display_name, u.email_address) display_name, p.lang, p.status, coalesce( p.title, 'Untitled' ) title, p.summary, p.detail, p.image, p.filename, p.filetype, p.slug, (

SELECT count( * )
FROM __DBPREFIX__post_comments
WHERE post_id = p.id
AND approved = 'true'
)comment_count, p.allow_comments, p.comment_email_notify, coalesce( c.category, 'Uncategorized' ) category, c.id cat_id, coalesce(c.slug, 'Uncategorized') cat_slug, (

SELECT group_concat( tag
ORDER BY tag )
FROM __DBPREFIX__tags
WHERE src_id = p.id AND tag_type = 'posts'
)tags, p.service, p.service_id
FROM __DBPREFIX__posts p
LEFT OUTER JOIN __DBPREFIX__users u ON u.user_id = p.user_id
LEFT OUTER JOIN __DBPREFIX__categories c ON c.id = p.category
);

-- command split --

CREATE VIEW __DBPREFIX__classifieds_view AS (
SELECT p.id, p.timestamp, DATE_FORMAT( p.timestamp, '%b %e, %Y' ) f_date, DATE_FORMAT( p.timestamp, '%l:%i%p' ) f_time, p.user_id, coalesce(u.display_name)  display_name, coalesce(u.email_address)  email_address, p.lang, p.status, coalesce( p.title, 'Untitled' ) title, p.summary, p.detail, p.image, p.filename, p.filetype, p.slug, (

SELECT count( * )
FROM __DBPREFIX__classified_answers
WHERE classified_id = p.id
AND approved = 'true'
)answer_count, p.allow_answers, p.answer_email_notify, coalesce( c.category, 'Uncategorized' ) category, c.id cat_id, coalesce(c.slug, 'Uncategorized') cat_slug, (

SELECT group_concat( tag
ORDER BY tag )
FROM __DBPREFIX__tags
WHERE src_id = p.id AND tag_type = 'classifieds'
)tags, p.service, p.service_id
FROM __DBPREFIX__classifieds p
LEFT OUTER JOIN __DBPREFIX__users u ON u.user_id = p.user_id
LEFT OUTER JOIN __DBPREFIX__categories c ON c.id = p.category
);

